#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>
#include	<sv_env.h>

#define	CLAUSE		"7.1.3b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef cfsetospeed
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for cfsetospeed. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CFSETOSPEED);
	funct(E_CFSETOSPEED);

	assertion(2, BASE);
	start
#ifdef cfsetospeed
		speed_t	speed;
		struct	termios	*termios_p;
		TYP_CHK_FUNCT_INT(cfsetospeed(termios_p, speed), int);
#else
		not_implemented("cfsetospeed() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	cfsetospeed
		if(system((char *)0)) {
			chk_mcro(E_CFSETOSPEED, CLAUSE);
		} else {
			prep("Obtain macro cfsetospeed() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that cfsetospeed() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("cfsetospeed() as a macro");
#endif
	finis


#undef	cfsetospeed

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int cfsetospeed(struct termios *, speed_t);
		finis
	finis

	done();
}
