#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Ztermios.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int	main(void)
{
	int		notty_fildes;
	struct	termios tty_termios;

	setup(E_TCGETATTR);
	funct(E_TCGETATTR);

	assertion(7, BASE);
	start
		testing("Call tcgetattr(invalid file descriptor).");
		start
			expecting(-1);
			expecting(EBADF);
			Ztcgetattr(-1, &tty_termios);
		finis
	finis

	assertion(8, BASE);
	start
		testing("Call tcgetattr(not a tty).");
		start
			notty_fildes = temp_open("notspec", O_RDWR|O_CREAT,S_IRUSR|S_IWUSR);

			expecting(-1);
			expecting(ENOTTY);
			Ztcgetattr(notty_fildes, &tty_termios);

			expecting(SUCCESS);
			Zclose(notty_fildes);
		finis
	finis

	done();
}
