#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcgetpgrp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcgetpgrp. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCGETPGRP);
	funct(E_TCGETPGRP);

	assertion(2, BASE);
	start
#ifdef tcgetpgrp
		int	fildes;
		TYP_CHK_FUNCT_INT(tcgetpgrp(fildes), pid_t);
#else
		not_implemented("tcgetpgrp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcgetpgrp
		if(system((char *)0)) {
			chk_mcro(E_TCGETPGRP, CLAUSE);
		} else {
			prep("Obtain macro tcgetpgrp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcgetpgrp() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcgetpgrp() as a macro");
#endif
	finis


#undef	tcgetpgrp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern pid_t tcgetpgrp(int);
		finis
	finis

	done();
}
