#include	<pcts_ass.h>

#include	<unistd.h>
#include	<sys/types.h>
#include	<limits.h>

#include	<sv_env.h>


int	main(void)
{
    setup(E_PSD_TYPES);
    funct(E_PSD_TYPES);

	assertion(2,BASE);
	start
		testing("Data types \"pid_t\", \"off_t\", and \"ssize_t\" are");
		testing("signed arithmetic.");
		start
			pid_t	pid;
			off_t	offset;
			ssize_t	size;

			pid = -1;
			if((int)pid != -1)
				error("Data type \"pid_t\" not signed arithmetic.");

			offset = -1;
			if((int)offset != -1)
				error("Data type \"off_t\" not signed arithmetic.");

			size = -1;
			if((int)size != -1)
				error("Data type \"ssize_t\" not signed arithmetic.");
		finis
    finis


	assertion(4, BASE);
    start
		testing("Type \"ssize_t\" is capable of storing values in the");
		testing(" range from -1 to {SSIZE_MAX}.");
		start
			ssize_t size;

			size = -1;
			if(-1 != size)
				error("Type \"ssize_t\" when set to \"-1\" yields %ld.",
								(long)size);

			size = SSIZE_MAX;
			if(SSIZE_MAX != size)
				error("%s%ld.\n%s%ld.\n",
						"Type \"ssize_t\" when set to {SSIZE_MAX} yields ",
						(long)size,
						"Expected: ",
						(long)SSIZE_MAX);
		finis
	finis

    done();
}
