#include	<pcts_ass.h>

#include	<unistd.h>

#include	<sv_env.h>

struct	acc_val	{
					const char	*name;
					const unsigned long value;
				} acc_value[] =	{
									"F_OK",			F_OK,
									"R_OK",			R_OK,
									"W_OK",			W_OK,
									"X_OK",			X_OK,
								   "R_OK|W_OK",		R_OK|W_OK,
								   "R_OK|X_OK",		R_OK|X_OK,
									"W_OK|X_OK",	W_OK|X_OK,
								   "R_OK|W_OK|X_OK",R_OK|W_OK|X_OK,
								};

#define	NUM_ENTRIES (sizeof(acc_value)/sizeof(acc_value[0]))


int	main(void)
{
    setup(E_SYM_CONST);
    funct(E_SYM_CONST);

	assertion(2, BASE);
	start
		testing("The constants F_OK, R_OK, W_OK, and X_OK are integral values.");
		start
			if((int)F_OK != F_OK)
				error("F_OK (%5.2f) is not an integral value.", F_OK);

			if((int)R_OK != R_OK)
				error("R_OK (%5.2f) is not an integral value.", R_OK);

			if((int)W_OK != W_OK)
				error("W_OK (%5.2f) is not an integral value.", W_OK);

			if((int)X_OK != X_OK)
				error("X_OK (%5.2f) is not an integral value.", X_OK);
		finis

		testing("The constants F_OK, R_OK, W_OK, X_OK, and the expresions");
		testing("R_OK|W_OK, R_OK|X_OK, W_OK|X_OK, and R_OK|W_OK|X_OK all");
		testing("have distinct values.");
		start
			UNIQUE_VALUES(acc_value, NUM_ENTRIES);
		finis
	finis

	done();
}
