#include	<pcts_ass.h>

#include	<unistd.h>

#include	<sv_env.h>

#define	POSIX_FIPS_VERSION	((long) 199009)

int	main(void)
{
    setup(E_SYM_CONST);
    funct(E_SYM_CONST);

	assertion(3, BASE);
    start
		testing("When <unistd.h> is included, then the constants SEEK_SET,");
		testing("SEEK_CUR, and SEEK_END are defined.");
		start

#ifndef	SEEK_SET
			error("Constant SEEK_SET not defined when <unistd.h> is included.");
#endif

#ifndef	SEEK_CUR
			error("Constant SEEK_CUR not defined when <unistd.h> is included.");
#endif

#ifndef	SEEK_END
			error("Constant SEEK_END not defined when <unistd.h> is included.");
#endif
		finis
	finis

	assertion(4, BASE);
	start
		testing("Constants SEEK_SET, SEEK_CUR and SEEK_END have distinct");
		testing("integral values.");
		start
			if(SEEK_SET == SEEK_END)
				error("SEEK_SET and SEEK_END are value %d\n", SEEK_SET);
			if(SEEK_SET == SEEK_CUR)
				error("SEEK_SET and SEEK_CUR are value %d\n", SEEK_SET);
			if(SEEK_CUR == SEEK_END)
				error("SEEK_CUR and SEEK_END are value %d\n", SEEK_CUR);

			if((int)SEEK_SET != SEEK_SET)
				error("SEEK_SET (%5.2f) is not an integral value.", SEEK_SET);

			if((int)SEEK_CUR != SEEK_CUR)
				error("SEEK_CUR (%5.2f) is not an integral value.", SEEK_CUR);

			if((int)SEEK_END != SEEK_END)
				error("SEEK_END (%5.2f) is not an integral value.", SEEK_END);
		finis
	finis

	assertion(5, BASE);
	start
		testing("{_POSIX_VERSION} is defined and matches the value '199009'.");
		start
			if(_POSIX_VERSION != POSIX_FIPS_VERSION)
				error("%s\n%s%ld\n%s%ld\n",
					"{_POSIX_VERSION} incorrect.",
					"Expected value of:	",
					POSIX_FIPS_VERSION,
					"Actual value obtained:	",
					_POSIX_VERSION);
		finis
	finis

    done();
}
