#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.6.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef access
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for access(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ACCESS);
	funct(E_ACCESS);

	assertion(2, BASE);
	start
#ifdef access
		TYP_CHK_FUNCT_INT(access("ABC", R_OK), int);
#else
		not_implemented("access() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	access
		if(system((char *)0)) {
			chk_mcro(E_ACCESS, CLAUSE);
		} else {
			prep("Obtain macro access() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that access() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("access() as a macro");
#endif
	finis


#undef	access

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int access(const char *, int);
		finis
	finis

	done();
}
