#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

/*	This module has the S_ISUID mode set to ROOT. */


int main(void)
{
	struct	stat st_buf;
	char	path_dir[_POSIX_PATH_MAX +1];
	char	path[_POSIX_PATH_MAX +1];
	int		fd;

	setup(E_CREAT);
	funct(E_CREAT);

	assertion(29, BASE);
	start
		prep("Create a test directory.");
		start
			Zstrcpy(path_dir, temp_path());
			Zstrcat(path_dir, "test_gid_dir");
			Zmkdir(path_dir, PROT_ALL);
		finis

		prep("Set group owner of test directory to BIN.");
		start
			Zchown(path_dir, UID, BIN_GID);
		finis

		if(GROUP_ID_OF_PARENT_DIR == 1) {
			prep("PCTS installation file <config>, states implementation");
			prep("requires S_ISGID mode bit set on directory to enable");
			prep("FIPS 151-2 required feature (\"l\").");
			start
				Zchmod(path_dir, S_IRWXU | S_IRWXG | S_ISGID);
			finis
		}

		prep("Chown effective user ID to UID.");
		start
			Zsetuid(UID);
		finis

		prep("Create a test file.");
		start
			Zstrcpy(path, path_dir);
			Zstrcat(path, "/test_gid_file");
			fd = Zcreat(path, PROT_ALL);
		finis

		testing("Group ID of a newly created file is set to the group ID");
		testing("of the directory in which the file is created.");
		testing("FIPS 151-2 required feature, Item \"l\".");
		start
			Zfstat(fd, &st_buf);
			if(st_buf.st_gid != BIN_GID)
				error("%s\n%s%lu\n%s%lu\n",
				  		"stat reported unexpected group-ID",
					  	"expected:	",
					  	(unsigned long) BIN_GID,
					  	"actual:	",
					  	(unsigned long) st_buf.st_gid);
		finis
	finis

	done();
}
