#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.7.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fpathconf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fpathconf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FPATHCONF);
	funct(E_FPATHCONF);

	assertion(2, BASE);
	start
#ifdef fpathconf
		TYP_CHK_FUNCT_INT(fpathconf(STDIN_FILENO, _PC_LINK_MAX), long);
#else
		not_implemented("fpathconf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fpathconf
		if(system((char *)0)) {
			chk_mcro(E_FPATHCONF, CLAUSE);
		} else {
			prep("Obtain macro fpathconf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fpathconf() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fpathconf() as a macro");
#endif
	finis


#undef	fpathconf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern long fpathconf(int, int);
		finis
	finis

	done();
}
