#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>


int main(void)
{
	DIR		*dirp;
	struct	dirent	*dirent;
	char	path[_POSIX_PATH_MAX +1];

	setup(E_OPENDIR);
	funct(E_OPENDIR);

	assertion(20, BASE);
	start
		testing("This should be a Referenced Assertion to assertions 5-16.");
		start
		finis
	finis

	assertion(21, BASE);
	start
		prep("Establish path to data directory and read first entry.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "data.d");
			dirp = Zopendir(path);
			dirent = Zreaddir(dirp);
		finis

		testing("Directory entry read was first entry created.");
		start
			if(strcmp(dirent->d_name, "."))
				if(strcmp(dirent->d_name, "first"))
					error("%s\n%s\"%s\"\n%s\"%s\"\n",
						"Incorrect entry returned.",
						"Expected:	",
						"\".\" or \"first\"",
						"Actual:	",
						dirent->d_name);
			Zclosedir(dirp);
		finis
	finis

	done();
}
