#include	<pcts_ass.h>

#include	<Zunistd.h>

#include	<sv_env.h>

struct	path_var {
		const char	*name;
		const unsigned long	value;
		} path_vars[] = {
			"_PC_LINK_MAX",			_PC_LINK_MAX,
			"_PC_MAX_CANON",		_PC_MAX_CANON,
			"_PC_MAX_INPUT",		_PC_MAX_INPUT,
			"_PC_NAME_MAX",			_PC_NAME_MAX,
			"_PC_PATH_MAX",			_PC_PATH_MAX,
			"_PC_PIPE_BUF",			_PC_PIPE_BUF,
			"_PC_CHOWN_RESTRICTED",	_PC_CHOWN_RESTRICTED,
			"_PC_NO_TRUNC",			_PC_NO_TRUNC,
			"_PC_VDISABLE",			_PC_VDISABLE,
		};
#define	ITEMS_PATH	(sizeof(path_vars)/sizeof(path_vars[0]))


int main(void)
{
	setup(E_PATHCONF);
	funct(E_PATHCONF);

	assertion(19, BASE);
	start
		testing("Symbolic constants defined in header <unistd.h>.");
		start
#ifndef	_PC_LINK_MAX
			error("_PC_LINK_MAX is not defined in <unistd.h>.");
#endif
#ifndef	_PC_MAX_CANON
			error("_PC_MAX_CANON is not defined in <unistd.h>.");
#endif
#ifndef	_PC_MAX_INPUT
			error("_PC_MAX_INPUT is not defined in <unistd.h>.");
#endif
#ifndef	_PC_NAME_MAX
			error("_PC_NAME_MAX is not defined in <unistd.h>.");
#endif
#ifndef	_PC_PATH_MAX
			error("_PC_PATH_MAX is not defined in <unistd.h>.");
#endif
#ifndef	_PC_PIPE_BUF
			error("_PC_PIPE_BUF is not defined in <unistd.h>.");
#endif
#ifndef	_PC_CHOWN_RESTRICTED
			error("_PC_CHOWN_RESTRICTED is not defined in <unistd.h>.");
#endif
#ifndef	_PC_NO_TRUNC
			error("_PC_NO_TRUNC is not defined in <unistd.h>.");
#endif
#ifndef	_PC_VDISABLE
			error("_PC_VDISABLE is not defined in <unistd.h>.");
#endif
		finis

		testing("When header <fcntl.h> is included, the symbolic constants");
		testing("_PC_LINK_MAX, _PC_MAX_CANON, _PC_MAX_INPUT, _PC_NAME_MAX,");
		testing("_PC_PATH_MAX, _PC_PIPE_BUF, _PC_CHOWN_RESTRICTED,");
		testing("_PC_NO_TRUNC, and _PC_VDISABLE are distinct.");
		start
			UNIQUE_VALUES(path_vars, ITEMS_PATH)
		finis
	finis

	done();
}
