#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<dirent.h>
#include	<sv_env.h>

#define	CLAUSE		"5.1.2c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef rewinddir
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for rewinddir(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_REWINDDIR);
	funct(E_REWINDDIR);

#ifdef rewinddir
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("rewinddir() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	rewinddir
		if(system((char *)0)) {
			chk_mcro(E_REWINDDIR, CLAUSE);
		} else {
			prep("Obtain macro rewinddir() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that rewinddir() macro provided in",
					"<dirent.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("rewinddir() as a macro");
#endif
	finis


#undef	rewinddir

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			void rewinddir(DIR *);
		finis
	finis

	done();
}
