#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.5.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef rmdir
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for rmdir(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_RMDIR);
	funct(E_RMDIR);

	assertion(2, BASE);
	start
#ifdef rmdir
		TYP_CHK_FUNCT_INT(rmdir("ABC"), int);
#else
		not_implemented("rmdir() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	rmdir
		if(system((char *)0)) {
			chk_mcro(E_RMDIR, CLAUSE);
		} else {
			prep("Obtain macro rmdir() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that rmdir() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("rmdir() as a macro");
#endif
	finis


#undef	rmdir

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int rmdir(const char *);
		finis
	finis

	done();
}
