#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sv_env.h>

#define	CLAUSE		"5.6.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef stat
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for stat(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STAT);
	funct(E_STAT);

	assertion(2, BASE);
	start
#ifdef stat
		struct	stat st_buf;
		TYP_CHK_FUNCT_INT(stat("ABC", &st_buf), int);
#else
		not_implemented("stat() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	stat
		if(system((char *)0)) {
			chk_mcro(E_STAT, CLAUSE);
		} else {
			prep("Obtain macro stat() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that stat() macro provided in",
					"<sys/stat.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("stat() as a macro");
#endif
	finis


#undef	stat

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int stat(const char *, struct stat *);
		finis
	finis

	done();
}
