#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sv_env.h>

#define	CLAUSE		"5.3.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef umask
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for umask(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_UMASK);
	funct(E_UMASK);

	assertion(2, BASE);
	start
#ifdef umask
		TYP_CHK_FUNCT_INT(umask(1), mode_t);
#else
		not_implemented("umask() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	umask
		if(system((char *)0)) {
			chk_mcro(E_UMASK, CLAUSE);
		} else {
			prep("Obtain macro umask() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that umask() macro provided in",
					"<sys/stat.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("umask() as a macro");
#endif
	finis


#undef	umask

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern mode_t umask(mode_t);
		finis
	finis

	done();
}
