#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"6.3.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef close
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for close. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CLOSE);
	funct(E_CLOSE);

	assertion(2, BASE);
	start
#ifdef close
		int	fildes;
		TYP_CHK_FUNCT_INT(close(fildes), int);
#else
		not_implemented("close() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	close
		if(system((char *)0)) {
			chk_mcro(E_CLOSE, CLAUSE);
		} else {
			prep("Obtain macro close() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that close() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("close() as a macro");
#endif
	finis


#undef	close

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int close(int);
		finis
	finis

	done();
}
