#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"6.2.1a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef dup
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for dup. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_DUP);
	funct(E_DUP);

	assertion(2, BASE);
	start
#ifdef dup
		int	fildes;
		TYP_CHK_FUNCT_INT(dup(fildes), int);
#else
		not_implemented("dup() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	dup
		if(system((char *)0)) {
			chk_mcro(E_DUP, CLAUSE);
		} else {
			prep("Obtain macro dup() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that dup() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("dup() as a macro");
#endif
	finis


#undef	dup

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int dup(int);
		finis
	finis

	done();
}
