#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"6.5.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef lseek
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for lseek(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_LSEEK);
	funct(E_LSEEK);

	assertion(2, BASE);
	start
#ifdef lseek
		int		fildes;
		off_t	offset;
		TYP_CHK_FUNCT_INT(lseek(fildes, offset, SEEK_SET), off_t);
#else
		not_implemented("lseek() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	lseek
		if(system((char *)0)) {
			chk_mcro(E_LSEEK, CLAUSE);
		} else {
			prep("Obtain macro lseek() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that lseek() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("lseek() as a macro");
#endif
	finis


#undef	lseek

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern off_t lseek(int, off_t, int);
		finis
	finis

	done();
}
