#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef atan
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for atan(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ATAN);
	funct(E_ATAN);

	assertion(2, BASE);
	start
#ifdef atan
		double	value;
		TYP_CHK_ENTITY(atan(value),double);
#else
		not_implemented("atan() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	atan
		if(system((char *)0)) {
			chk_mcro(E_ATAN, CLAUSE);
		} else {
			prep("Obtain macro atan() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that atan() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("atan() as a macro");
#endif
	finis


#undef	atan

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double atan(double);
		finis
	finis

	done();
}
