#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.45a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef atof
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for atof(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ATOF);
	funct(E_ATOF);

	assertion(2, BASE);
	start
#ifdef atof
		char	str[] = "1";
		TYP_CHK_FUNCT(atof(str), double);
#else
		not_implemented("atof() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	atof
		if(system((char *)0)) {
			chk_mcro(E_ATOF, CLAUSE);
		} else {
			prep("Obtain macro atof() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that atof() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("atof() as a macro");
#endif
	finis


#undef	atof

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double atof(const char *);
		finis
	finis

	done();
}
