#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.45b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef atoi
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for atoi(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ATOI);
	funct(E_ATOI);

	assertion(2, BASE);
	start
#ifdef atoi
		char	str[] = "1";
		TYP_CHK_FUNCT_INT(atoi(str), int);
#else
		not_implemented("atoi() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	atoi
		if(system((char *)0)) {
			chk_mcro(E_ATOI, CLAUSE);
		} else {
			prep("Obtain macro atoi() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that atoi() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("atoi() as a macro");
#endif
	finis


#undef	atoi

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int atoi(const char *);
		finis
	finis

	done();
}
