#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4g"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef cosh
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for cosh(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_COSH);
	funct(E_COSH);

	assertion(2, BASE);
	start
#ifdef cosh
		double	value;
		TYP_CHK_ENTITY(cosh(value),double);
#else
		not_implemented("cosh() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	cosh
		if(system((char *)0)) {
			chk_mcro(E_COSH, CLAUSE);
		} else {
			prep("Obtain macro cosh() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that cosh() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("cosh() as a macro");
#endif
	finis


#undef	cosh

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double cosh(double);
		finis
	finis

	done();
}
