#include	<pcts.h>

#include	<sv_env.h>
#include	"./c_locale.h"


int	main(void)
{
	time_t	timer;
	char	tz_env[100];				/* Contains TZ environment */
	int		hours, minutes, seconds;
	int		i;

	setup(E_CTIME);
	funct(E_CTIME);

	assertion(4, BASE);
	start
		prep("Setup environment for testing.");
		start
			sprintf(tz_env, "TZ=UCT0");
			environ[0] = (char *)0;
			put_env(tz_env);	/* Establish TZ environment.		*/

			timer = c_timer(1992,0,0,0,0);
		finis

		testing("TZ is of the form: TZ=%s", getenv("TZ"));
		start
			UTC_TIME
			LOC_TIME(0)
		finis
	finis

	assertion(6, BASE);
	start
		for(hours=0; hours<24; hours++) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst-%2.2d", hours);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				timer = c_timer(1992,0,0,0,0);
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			start
				UTC_TIME
				LOC_TIME(hours*SECS_PER_HOUR)
			finis
		}
	finis


	assertion(7, BASE);
	start
	  for(i=0; i<2; i++) {
		for(hours=0; hours<24; hours += 5) {
		  for(minutes=0; minutes<60; minutes += 10) {
			prep("Setup environment for testing.");
			start
				if(i==0)
					sprintf(tz_env, "TZ=dst%2.2d:%2.2d", hours, minutes);
				else
					sprintf(tz_env, "TZ=dst+%2.2d:%2.2d", hours, minutes);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				timer = c_timer(1992,31,5,5,5);
			finis

			if(i==0)
				testing("TZ is of the form: TZ=%s", getenv("TZ"));
			else
				testing("TZ is of the form: TZ=%s", getenv("TZ"));
			start
				UTC_TIME
				LOC_TIME(-hours*SECS_PER_HOUR -minutes*SECS_PER_MINUTE)
			finis
		  }
		}
	  }
	finis


	assertion(8, BASE);
	start
	  for(hours=0; hours<24; hours += 23) {
		for(minutes=0; minutes<60; minutes += 59) {
		  for(seconds=0; seconds<60; seconds += 59) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst-%2.2d:%2.2d:%2.2d",
											hours, minutes,seconds);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				timer = c_timer(1992,60,5,5,5);
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			start
				UTC_TIME
				LOC_TIME(hours*SECS_PER_HOUR +minutes*SECS_PER_MINUTE +seconds)
			finis
		  }
		}
	  }
	finis

	done();
}
