#include	<pcts.h>

#include	<sv_env.h>
#include	"./c_locale.h"

int	main(void)
{
	time_t	timer;
	char	tz_env[100];				/* Contains TZ environment */
	int		i;

	setup(E_CTIME);
	funct(E_CTIME);

	assertion(14, BASE);
	start
		for(i=0; i<MWD_ENTRIES; i++) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env,
						"TZ=dst0std,M%.2d.%1.1d.%1.1d,M%.2d.%1.1d.%1.1d",
						mwd[i].month_beg, mwd[i].week_beg, mwd[i].day_beg,
						mwd[i].month_end, mwd[i].week_end, mwd[i].day_end);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("One second prior to summer time change date.");
			start
								/*	timer -> UTC clock ticks	*/
				timer = c_timer(1992, mwd[i].start_day, 1, 59, 59);
				UTC_TIME
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("At summer time change date.");
			start
				timer = c_timer(1992, mwd[i].start_day, 2, 00, 00);
				UTC_TIME
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("One second past summer time change date.");
			start
				timer = c_timer(1992, mwd[i].start_day, 2, 00, 01);
				UTC_TIME
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("One second prior to standard time change date.");
			start
				timer = c_timer(1992, mwd[i].end_day, 0, 59, 59);
				UTC_TIME
				LOC_TIME(SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("At standard time change date.");
			start
				timer = c_timer(1992, mwd[i].end_day, 1, 00, 00);
				UTC_TIME
				LOC_TIME(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("One second past standard time change date.");
			start
				timer = c_timer(1992, mwd[i].end_day, 1, 00, 01);
				UTC_TIME
				LOC_TIME(0)
			finis
		}
	finis

	done();
}
