#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4j"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef exp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for exp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXP);
	funct(E_EXP);

	assertion(2, BASE);
	start
#ifdef exp
		double	value;
		TYP_CHK_ENTITY(exp(value),double);
#else
		not_implemented("exp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	exp
		if(system((char *)0)) {
			chk_mcro(E_EXP, CLAUSE);
		} else {
			prep("Obtain macro exp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that exp() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("exp() as a macro");
#endif
	finis


#undef	exp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double exp(double);
		finis
	finis

	done();
}
