#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.9"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef feof
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for feof(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FEOF);
	funct(E_FEOF);

	assertion(2, BASE);
	start
#ifdef feof
		TYP_CHK_FUNCT_INT(feof(stdout), int);
#else
		not_implemented("feof() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	feof
		if(system((char *)0)) {
			chk_mcro(E_FEOF, CLAUSE);
		} else {
			prep("Obtain macro feof() from  proper header.");
			start
			prep("Obtain macro feof() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that feof() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
			finis
		}
#else
	not_implemented("feof() as a macro");
#endif
	finis


#undef	feof

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int feof(FILE *);
		finis
	finis

	done();
}
