#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.11"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fflush
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fflush(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FFLUSH);
	funct(E_FFLUSH);

	assertion(2, BASE);
	start
#ifdef fflush
		TYP_CHK_FUNCT_INT(fflush(stdout), int);
#else
		not_implemented("fflush() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fflush
		if(system((char *)0)) {
			chk_mcro(E_FFLUSH, CLAUSE);
		} else {
			prep("Obtain macro fflush() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fflush() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fflush() as a macro");
#endif
	finis


#undef	fflush

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fflush(FILE *);
		finis
	finis

	done();
}
