#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.14"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fopen
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fopen(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FOPEN);
	funct(E_FOPEN);

	assertion(2, BASE);
	start
#ifdef fopen
		char 	*path;
		char	mode[] = "r";
		TYP_CHK_ENTITY_PTR(fopen(path, mode), FILE);
#else
		not_implemented("fopen() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fopen
		if(system((char *)0)) {
			chk_mcro(E_FOPEN, CLAUSE);
		} else {
			prep("Obtain macro fopen() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fopen() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fopen() as a macro");
#endif
	finis


#undef	fopen

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern FILE *fopen(const char *, const char *);
		finis
	finis

	done();
}
