#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.17"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fread
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fread(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FREAD);
	funct(E_FREAD);

	assertion(2, BASE);
	start
#ifdef fread
		char	*s;
		TYP_CHK_ENTITY(fread(s, sizeof(*s), 1, stdin), size_t);
#else
		not_implemented("fread() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fread
		if(system((char *)0)) {
			chk_mcro(E_FREAD, CLAUSE);
		} else {
			prep("Obtain macro fread() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fread() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fread() as a macro");
#endif
	finis


#undef	fread

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern size_t fread(void *, size_t, size_t, FILE *);
		finis
	finis

	done();
}
