#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.18"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef freopen
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for freopen(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FREOPEN);
	funct(E_FREOPEN);

	assertion(2, BASE);
	start
#ifdef freopen
		char	*filename;
		char	mode[] = "r+";
		TYP_CHK_ENTITY(freopen(filename, mode, stdin), FILE *);
#else
		not_implemented("freopen() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	freopen
		if(system((char *)0)) {
			chk_mcro(E_FREOPEN, CLAUSE);
		} else {
			prep("Obtain macro freopen() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that freopen() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("freopen() as a macro");
#endif
	finis


#undef	freopen

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern FILE *freopen(const char *, const char *, FILE *);
		finis
	finis

	done();
}
