#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.19"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fseek
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fseek(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FSEEK);
	funct(E_FSEEK);

	assertion(2, BASE);
	start
#ifdef fseek
		TYP_CHK_FUNCT_INT(fseek(stdout, 0L, SEEK_SET), int);
#else
		not_implemented("fseek() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fseek
		if(system((char *)0)) {
			chk_mcro(E_FSEEK, CLAUSE);
		} else {
			prep("Obtain macro fseek() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fseek() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fseek() as a macro");
#endif
	finis


#undef	fseek

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int	fseek(FILE *, long int, int);
		finis
	finis

	done();
}
