#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "8.1.22_04"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	FILE	*sfd;
	int		fd;

	setup(E_GETC);
	funct(E_GETC);

								/*	This assertion test contains code similar
									to that of fgetc(). */
	assertion(4, BASE);
	start
		time_t	s_time;

		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
			Zfclose(sfd);
		finis

		testing("A call to getc() marks for update the \"st_atime\"");
		testing("time-related field of the underlying file.");
		start
			sfd = Zfopen(path, "r");
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			Zgetc(sfd);
			fd = Zfileno(sfd);
			trf_ck(CHK_ATIME, TRUE, s_time, fd, NO_PATH);
		finis
	finis

	done();
}
