#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "8.1.24_04"
char	String[] = "Hello, world!\n";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	inbuf[Strlen];
	FILE	*sfd;
	pid_t	pid;

	setup(E_GETS);
	funct(E_GETS);
								/*	This assertion test contains code similar
									to that of getchar(). */
	assertion(4, BASE);
	start
		time_t	s_time;

		prep("Establish path to test file and create it.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
			Zfclose(sfd);
		finis

		FORK
			testing("A call to gets() marks for update the \"st_atime\"");
			testing("time-related field of the underlying file.");
			start
				freopen(path, "r", stdin);
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.	*/
				Zgets(inbuf);
				trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
			finis
		KROF
	finis

	done();
}
