#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.24"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef gets
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for gets(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETS);
	funct(E_GETS);

	assertion(2, BASE);
	start
#ifdef gets
		char	*s;
		TYP_CHK_ENTITY(gets(s), char *);
#else
		not_implemented("gets() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	gets
		if(system((char *)0)) {
			chk_mcro(E_GETS, CLAUSE);
		} else {
			prep("Obtain macro gets() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that gets() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("gets() as a macro");
#endif
	finis


#undef	gets

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *gets(char *);
		finis
	finis

	done();
}
