#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2f"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef islower
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for islower(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISLOWER);
	funct(E_ISLOWER);

	assertion(2, BASE);
	start
#ifdef islower
		TYP_CHK_FUNCT_INT(islower(1),int);
#else
		not_implemented("islower() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	islower
		if(system((char *)0)) {
			chk_mcro(E_ISLOWER, CLAUSE);
		} else {
			prep("Obtain macro islower() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that islower() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("islower() as a macro");
#endif
	finis


#undef	islower

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int islower(int);
		finis
	finis

	done();
}
