#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4l"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef log10
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for log10(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_LOG10);
	funct(E_LOG10);

	assertion(2, BASE);
	start
#ifdef log10
		double	value;
		TYP_CHK_ENTITY(log10(value),double);
#else
		not_implemented("log10() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	log10
		if(system((char *)0)) {
			chk_mcro(E_LOG10, CLAUSE);
		} else {
			prep("Obtain macro log10() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that log10() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("log10() as a macro");
#endif
	finis


#undef	log10

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double log10(double);
		finis
	finis

	done();
}
