#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.48c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef malloc
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for malloc(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_MALLOC);
	funct(E_MALLOC);

	assertion(2, BASE);
	start
#ifdef malloc
		TYP_CHK_PTR_VOID(malloc(1), void);
#else
		not_implemented("malloc() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	malloc
		if(system((char *)0)) {
			chk_mcro(E_MALLOC, CLAUSE);
		} else {
			prep("Obtain macro malloc() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that malloc() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("malloc() as a macro");
#endif
	finis


#undef	malloc

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void *malloc(size_t);
		finis
	finis

	done();
}
