#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4r"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef pow
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for pow(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_POW);
	funct(E_POW);

	assertion(2, BASE);
	start
#ifdef pow
		double	value,value2;
		TYP_CHK_ENTITY(pow(value,value2),double);
#else
		not_implemented("pow() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	pow
		if(system((char *)0)) {
			chk_mcro(E_POW, CLAUSE);
		} else {
			prep("Obtain macro pow() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that pow() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("pow() as a macro");
#endif
	finis


#undef	pow

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double pow(double,double);
		finis
	finis

	done();
}
