#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.26"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef printf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for printf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_PRINTF);
	funct(E_PRINTF);

	assertion(2, BASE);
	start
#ifdef printf
		char	msg[] = "Hi";
		TYP_CHK_FUNCT_INT(printf(msg), int);
#else
		not_implemented("printf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	printf
		if(system((char *)0)) {
			chk_mcro(E_PRINTF, CLAUSE);
		} else {
			prep("Obtain macro printf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that printf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("printf() as a macro");
#endif
	finis


#undef	printf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int printf(const char *, ...);
		finis
	finis

	done();
}
