#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.33"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef puts
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for puts(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_PUTS);
	funct(E_PUTS);

	assertion(2, BASE);
	start
#ifdef puts
		char	str[] = "Hi";
		TYP_CHK_FUNCT_INT(puts(str), int);
#else
		not_implemented("puts() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	puts
		if(system((char *)0)) {
			chk_mcro(E_PUTS, CLAUSE);
		} else {
			prep("Obtain macro puts() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that puts() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("puts() as a macro");
#endif
	finis


#undef	puts

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int puts(const char *);
		finis
	finis

	done();
}
