#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.48d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef realloc
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for realloc(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_REALLOC);
	funct(E_REALLOC);

	assertion(2, BASE);
	start
#ifdef realloc
		TYP_CHK_PTR_VOID(realloc((char *)0, 1), void);
#else
		not_implemented("realloc() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	realloc
		if(system((char *)0)) {
			chk_mcro(E_REALLOC, CLAUSE);
		} else {
			prep("Obtain macro realloc() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that realloc() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("realloc() as a macro");
#endif
	finis


#undef	realloc

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void *realloc(void *, size_t);
		finis
	finis

	done();
}
