#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.37"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef scanf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for scanf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SCANF);
	funct(E_SCANF);

	assertion(2, BASE);
	start
#ifdef scanf
		char	c;
		char	msg[] = "%c";
		TYP_CHK_FUNCT_INT(scanf(msg, &c), int);
#else
		not_implemented("scanf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	scanf
		if(system((char *)0)) {
			chk_mcro(E_SCANF, CLAUSE);
		} else {
			prep("Obtain macro scanf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that scanf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("scanf() as a macro");
#endif
	finis


#undef	scanf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int scanf(const char *, ...);
		finis
	finis

	done();
}
