#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.28"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sprintf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sprintf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SPRINTF);
	funct(E_SPRINTF);

	assertion(2, BASE);
	start
#ifdef printf
		char	buf[3];
		char	msg[] = "Hi";
		TYP_CHK_FUNCT_INT(sprintf(buf, msg), int);
#else
		not_implemented("sprintf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sprintf
		if(system((char *)0)) {
			chk_mcro(E_SPRINTF, CLAUSE);
		} else {
			prep("Obtain macro sprintf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sprintf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sprintf() as a macro");
#endif
	finis


#undef	sprintf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sprintf(char *, const char *, ...);
		finis
	finis

	done();
}
