#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4m"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sqrt
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sqrt(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SQRT);
	funct(E_SQRT);

	assertion(2, BASE);
	start
#ifdef sqrt
		double	value;
		TYP_CHK_ENTITY(sqrt(value),double);
#else
		not_implemented("sqrt() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sqrt
		if(system((char *)0)) {
			chk_mcro(E_SQRT, CLAUSE);
		} else {
			prep("Obtain macro sqrt() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sqrt() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sqrt() as a macro");
#endif
	finis


#undef	sqrt

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double sqrt(double);
		finis
	finis

	done();
}
