#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strcat
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strcat(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRCAT);
	funct(E_STRCAT);

	assertion(2, BASE);
	start
#ifdef strcat
		char	*s1, *s2;
		TYP_CHK_FUNCT_PTR(strcat(s1, s2), char);
#else
		not_implemented("strcat() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strcat
		if(system((char *)0)) {
			chk_mcro(E_STRCAT, CLAUSE);
		} else {
			prep("Obtain macro strcat() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strcat() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strcat() as a macro");
#endif
	finis


#undef	strcat

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strcat(char *, const char *);
		finis
	finis

	done();
}
