#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strcpy
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strcpy(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRCPY);
	funct(E_STRCPY);

	assertion(2, BASE);
	start
#ifdef strcpy
		char	*s1, *s2;
		TYP_CHK_FUNCT_PTR(strcpy(s1, s2), char);
#else
		not_implemented("strcpy() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strcpy
		if(system((char *)0)) {
			chk_mcro(E_STRCPY, CLAUSE);
		} else {
			prep("Obtain macro strcpy() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strcpy() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strcpy() as a macro");
#endif
	finis


#undef	strcpy

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strcpy(char *, const char *);
		finis
	finis

	done();
}
