#include	<pcts.h>

#include	<sv_env.h>

extern	char **environ;
extern	char *tzname[2];

#define	Strlen	10
static	char	String[Strlen];


int	main(void)
{
	char	tz_env[100];				/* Contains TZ environment */
	struct	tm *tm;
	time_t	timer = 1000;

	setup(E_STRFTIME);
	funct(E_STRFTIME);


	assertion(7, BASE);
	start
		prep("Setup environment for testing and call strftime().");
		start
			tm = localtime(&timer);
			sprintf(tz_env, "TZ=dst0std");
			environ[0] = (char *)0;
			put_env(tz_env);				/* Establish TZ environment.	*/
			(void) strftime(String, Strlen, "%Z", tm);
		finis

		testing("TZ is of the form: TZ=%s", getenv("TZ"));
		testing("tzname[0] points to the standard timezone designation.");
		testing("tzname[1] points to the summer timezone designation.");
		start
			if(strncmp(tzname[0], getenv("TZ"), 3))
				error("tzname[0]: %s\nStandard designation: %3.3s",
												tzname[0], getenv("TZ"));
			if(strcmp(tzname[1], getenv("TZ") +4))
				error("tzname[1]: %s\nStandard designation: %3.3s",
												tzname[1], getenv("TZ") +4);
		finis


		prep("Setup environment for testing and call strftime().");
		start
			sprintf(tz_env, "TZ=ABC0DEF");
			environ[0] = (char *)0;
			put_env(tz_env);				/* Establish TZ environment.	*/
			(void) strftime(String, Strlen, "%Z", tm);
		finis

		testing("TZ is of the form: TZ=%s", getenv("TZ"));
		testing("tzname[0] points to the standard timezone designation.");
		testing("tzname[1] points to the summer timezone designation.");
		start
			if(strncmp(tzname[0], getenv("TZ"), 3))
				error("tzname[0]: %s\nStandard designation: %3.3s",
												tzname[0], getenv("TZ"));
			if(strcmp(tzname[1], getenv("TZ") +4))
				error("tzname[1]: %s\nStandard designation: %3.3s",
												tzname[1], getenv("TZ") +4);
		finis
	finis

	assertion(8, BASE);
	start
		testing("Tested in assertions #5 and #6.");
		start
		finis
	finis

	done();
}
