#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53l"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strstr
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strstr(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRSTR);
	funct(E_STRSTR);

	assertion(2, BASE);
	start
#ifdef strstr
		char	*s1, *s2;
		TYP_CHK_FUNCT_PTR(strstr(s1, s2), char);
#else
		not_implemented("strstr() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strstr
		if(system((char *)0)) {
			chk_mcro(E_STRSTR, CLAUSE);
		} else {
			prep("Obtain macro strstr() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strstr() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strstr() as a macro");
#endif
	finis


#undef	strstr

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strstr(const char *, const char *);
		finis
	finis

	done();
}
