#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<stdio.h>

#include	<sv_env.h>

#define	CLAUSE		"4.7.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef ctermid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for ctermid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CTERMID);
	funct(E_CTERMID);

	assertion(2, BASE);
	start
#ifdef ctermid
		char *path;
		TYP_CHK_FUNCT_PTR(ctermid(path), char);
#else
		not_implemented("ctermid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	ctermid
		if(system((char *)0)) {
			chk_mcro(E_CTERMID, CLAUSE);
		} else {
			prep("Obtain macro ctermid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that ctermid() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("ctermid() as a macro");
#endif
	finis


#undef	ctermid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *ctermid(char *);
		finis
	finis

	done();
}
