#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.1.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getppid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getppid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETPPID);
	funct(E_GETPPID);

	assertion(2, BASE);
	start
#ifdef getppid
		TYP_CHK_FUNCT_INT(getppid(),pid_t);
#else
		not_implemented("getppid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getppid
		if(system((char *)0)) {
			chk_mcro(E_GETPPID, CLAUSE);
		} else {
			prep("Obtain macro getppid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getppid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getppid() as a macro");
#endif
	finis


#undef	getppid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern pid_t getppid(void);
		finis
	finis

	done();
}
