#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

/* 	This module has S_ISUID of BIN_UID.  */

int	main(void)
{
	setup(E_GETUID);
	funct(E_GETUID);

	assertion(4, BASE);
	start
		prep("Ensure effective user-ID is BIN.");
		start
			if(geteuid() != BIN_UID)
				error("%s\n%s%lu.\n%s%lu.",
					"Incorrect effective user-ID for testing.",
					"Expected user-ID: ",
					(unsigned long) BIN_UID,
					"Actual user-ID: ",
					(unsigned long) geteuid());
		finis

		testing("Getuid() returns the real user-ID of the calling process.");
		start
			uid_t	ret_val;

			ret_val = getuid();
			if(ret_val != UID)
				error("%s\n%s%lu.\n%s%lu.",
					"Incorrect return value from getuid.",
					"Expected user-ID: ",
					(unsigned long) UID,
					"Actual user-ID: ",
					(unsigned long) ret_val);
		finis
	finis

	done();
}
