#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.3.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef setsid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for setsid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SETSID);
	funct(E_SETSID);

	assertion(2, BASE);
	start
#ifdef setsid
		TYP_CHK_FUNCT_INT(setsid(),pid_t);
#else
		not_implemented("setsid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	setsid
		if(system((char *)0)) {
			chk_mcro(E_SETSID, CLAUSE);
		} else {
			prep("Obtain macro setsid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that setsid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("setsid() as a macro");
#endif
	finis


#undef	setsid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern pid_t setsid(void);	
		finis
	finis

	done();
}
