#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.8.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sysconf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for sysconf. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SYSCONF);
	funct(E_SYSCONF);

	assertion(2, BASE);
	start
#ifdef sysconf
		int	name;
		TYP_CHK_FUNCT_INT(sysconf(name), long);
#else
		not_implemented("sysconf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sysconf
		if(system((char *)0)) {
			chk_mcro(E_SYSCONF, CLAUSE);
		} else {
			prep("Obtain macro sysconf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sysconf() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sysconf() as a macro");
#endif
	finis


#undef	sysconf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern long sysconf(int);
		finis
	finis

	done();
}
