#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.4.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef alarm
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for alarm(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ALARM);
	funct(E_ALARM);

	assertion(2, BASE);
	start
#ifdef alarm
		TYP_CHK_FUNCT_INT(alarm(0), unsigned);
#else
		not_implemented("alarm() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	alarm
		if(system((char *)0)) {
			chk_mcro(E_ALARM, CLAUSE);
		} else {
			prep("Obtain macro alarm() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that alarm() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("alarm() as a macro");
#endif
	finis


#undef	alarm

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern unsigned int alarm(unsigned int);
		finis
	finis

	done();
}
