#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_sigs.h>

int main(void)
{
	struct	sigaction c_sigaction, o_sigaction;
	int		i;

	ass_nu = 40;
	sv_config();					/* Required for next line			  */
	sv_nproc();						/* Maintain proper jounal ID sequence */

	prep("Prepare for sigaction calls.");
	start
		Zsigemptyset(&c_sigaction.sa_mask);
		c_sigaction.sa_handler = SIG_IGN;
		c_sigaction.sa_flags = 0;
	finis

	for(i=0; i<NSIGS; i++) {
		if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP) ||
						(sigs[i].sig == SIGCHLD))
				continue;

		testing("Signal action of signal %s is SIG_IGN.", sigs[i].signame);
		start
			Zsigaction(sigs[i].sig, &c_sigaction, &o_sigaction);
			if(o_sigaction.sa_handler != SIG_IGN)
				error("Signal action of signal %s not SIG_IGN.",
						sigs[i].signame);
		finis
	}

	done();
}
