#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

#define	FILENAME	"./3.1.2_46x"
#define	PARAMETERS	a_indx
#include	"exec.h"


int	main(int argc, char *argv[])
{
	SETUP_FOR_EXEC

	if(PCTS_CHMOD_SET_IDS != 0) {
		assertion(46, BASE);
		start
			if(Zsysconf(_SC_SAVED_IDS) == (long) -1) {
				error("{_POSIX_SAVED_IDS} not suported.");
				done();
			}
	
			prep("Check that IDs are as expected.");
			start
				exit_on(ERROR);
	
				environ[0] = (char *)0;			/* Reset "environ". */
				expecting(UID);
				Zgetuid();
				expecting(GID);
				Zgetgid();
			finis
	
			FORK
				EXEC_MODULE(FILENAME)
			KROF
		finis
	}
	else
		assertion(46, NOT_TESTABLE);

	done();
}
