#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef execl
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for execl(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXECL);
	funct(E_EXECL);

	assertion(2, BASE);
	start
#ifdef execl
		TYP_CHK_FUNCT_INT(execl("ABC", "ABCD"), int);
#else
		not_implemented("execl() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	execl
		if(system((char *)0)) {
			chk_mcro(E_EXECL, CLAUSE);
		} else {
			prep("Obtain macro execl() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that execl() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("execl() as a macro");
#endif
	finis


#undef	execl

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int execl(const char *, const  char *, ...);
		finis
	finis

	done();
}
