#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

/* This module has S_ISUID set to BIN_UID and S_ISGID set to BIN_GID. */

int	main(void)
{
	pid_t	pid;

	setup(E_FORK);
	funct(E_FORK);

	assertion(17, BASE);
	start
		if(Zsysconf(_SC_SAVED_IDS) == (long) -1) {
			error("FIPS 151-2 requirement _POSIX_SAVED_IDS not supported.");
			done();
		}

		prep("Check that IDs are as expected.");
		start
			expecting(UID);
			Zgetuid();
			expecting(GID);
			Zgetgid();
			expecting(BIN_UID);
			Zgeteuid();
			expecting(BIN_GID);
			Zgetegid();
		finis
	
		FORK
			prep("Set effective user and group IDs to UID and GID respectively.");
			start
				Zsetuid(UID);
				Zsetgid(GID);
			finis
		
			testing("Saved set-user ID same as parent.");
			start
				expecting(SUCCESS);
				Zsetuid(BIN_UID);
				expecting(BIN_UID);
				Zgeteuid();
			finis
		
			testing("Saved set-group ID same as parent.");
			start
				expecting(SUCCESS);
				Zsetgid(BIN_GID);
				expecting(BIN_GID);
				Zgetegid();
			finis
		KROF
	finis

	done();
}
