#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.3c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigaddset
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigaddset(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGADDSET);
	funct(E_SIGADDSET);

	assertion(2, BASE);
	start
#ifdef sigaddset
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigaddset(&set, SIGINT), int);
#else
		not_implemented("sigaddset() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigaddset
		if(system((char *)0)) {
			chk_mcro(E_SIGADDSET, CLAUSE);
		} else {
			prep("Obtain macro sigaddset() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigaddset() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigaddset() as a macro");
#endif
	finis


#undef	sigaddset

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigaddset(sigset_t *, int);
		finis
	finis

	done();
}
