#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.3d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigdelset
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigdelset(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGDELSET);
	funct(E_SIGDELSET);

	assertion(2, BASE);
	start
#ifdef sigdelset
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigdelset(&set, SIGINT), int);
#else
		not_implemented("sigdelset() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigdelset
		if(system((char *)0)) {
			chk_mcro(E_SIGDELSET, CLAUSE);
		} else {
			prep("Obtain macro sigdelset() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigdelset() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigdelset() as a macro");
#endif
	finis


#undef	sigdelset

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigdelset(sigset_t *, int);
		finis
	finis

	done();
}
