#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>

int	main(void)
{
	setup(E_SIGEMPTYSET);
	funct(E_SIGEMPTYSET);

	assertion(4, BASE);
	start
		sigset_t	set;
		int			i, st;

		prep("Initialize signal set to all members set.");
		start
			Zsigfillset(&set);
			for(i=0; i<NSIGS; i++) {
				st = sigismember(&set, sigs[i].sig);
				if(st != 1)
					error("Signal %s is not a member of the initialized set .",
								sigs[i].signame);
			}
		finis

		testing("Sigemptyset() initializes the signal set such that all ");
		testing("signals defined in this standard are excluded and a value");
		testing("of zero is returned.");
		start
			Zsigemptyset(&set);
			for(i=0; i<NSIGS; i++) {
				st = sigismember(&set, sigs[i].sig);
				if(st != 0)
					error("Signal %s is a member of the initialized set .",
								sigs[i].signame);
			}
		finis
	finis

	done();
}
