#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

#define	FILENAME1	"./3.3.1_31x"
#define	FILENAME2	"./3.3.1_31y"

extern	char	**environ;


int main(void)
{
	pid_t 	pid;
	int		i;
	
	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(31, BASE);
	start
		FORK
			prep("Establish all signals with action of SIG_DFL, then exec");
			prep("a new process image.");
			start
				environ[0] = (char *)0;			/* Reset "environ". */
				for(i=0; i<NSIGS; i++) {
					if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP))
						continue;
					SIGNAL(sigs[i].sig, SIG_DFL);
				}

				Zexecl(FILENAME1, (char *)0);
			finis
		KROF

		FORK
			prep("Establish most signals with action of SIG_IGN.");
			start
				for(i=0; i<NSIGS; i++) {
					if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP) ||
							(sigs[i].sig == SIGCHLD))
						continue;
					SIGNAL(sigs[i].sig, SIG_IGN);
				}

				Zexecl(FILENAME2, (char *)0);
			finis
		KROF

		FORK
			prep("Establish most signals with action to be caught.");
			start
				for(i=0; i<NSIGS; i++) {
					if((sigs[i].sig == SIGKILL) || (sigs[i].sig == SIGSTOP))
						continue;
					SIGNAL(sigs[i].sig, sig_int);
				}

				Zexecl(FILENAME1, (char *)0);
			finis
		KROF
	finis

	done();
}
