#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/wait.h>
#include	<sv_env.h>

#define	CLAUSE		"3.2.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef waitpid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for waitpid(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_WAITPID);
	funct(E_WAITPID);

	assertion(2, BASE);
	start
#ifdef waitpid
		int		*stat_loc;
		TYP_CHK_FUNCT_INT(waitpid(1, stat_loc, WNOHANG), pid_t);
#else
		not_implemented("waitpid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	waitpid
		if(system((char *)0)) {
			chk_mcro(E_WAITPID, CLAUSE);
		} else {
			prep("Obtain macro waitpid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that waitpid() macro provided in",
					"<sys/wait.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("waitpid() as a macro");
#endif
	finis


#undef	waitpid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern pid_t waitpid(pid_t, int *, int);
		finis
	finis

	done();
}
