/************************************
* c_cflag baud rate array 
* for speed tests
************************************/
struct baud_table
{
  	const	char name[8];				/* name string					*/
	const	tcflag_t mask;				/* baud rate mask				*/
	const	speed_t value;				/* unsigned baud rate value		*/
	int 	supported;					/* settable by cfset[io]speed	*/
	int 	failed;						/* passed write/read test		*/
} baud[] =
{
	"B0",		B0,		0,		0,	0,
	"B50",		B50,	50,		0,	0,
	"B75",		B75,	75,		0,	0,
	"B110",		B110,	110,	0,	0,
	"B134",		B134,	134,	0,	0,
	"B150",		B150,	150,	0,	0,
	"B200",		B200,	200,	0,	0,
	"B300",		B300,	300,	0,	0,
	"B600",		B600,	600,	0,	0,
	"B1200",	B1200,	1200,	0,	0,
	"B1800",	B1800,	1800,	0,	0,
	"B2400",	B2400,	2400,	0,	0,
	"B4800",	B4800,	4800,	0,	0,
	"B9600",	B9600,	9600,	0,	0,
	"B19200",	B19200,	19200,	0,	0,
	"B38400",	B38400,	38400,	0,	0
};
#define SPEEDS (sizeof(baud)/sizeof(struct baud_table))
