#include <string.h>

/*	This include file contains macros for testing the Synopsis assertions
	for macros dealing with required parentheses.
*/

extern	void	_exit(int);	/*	Avoid possible warning message on _exit().	*/
#define	MAC_ELEMENT_RET 10
#define	INSTALL_CALL	"install"
#define	MACRO_TEST_DESIGNATOR	"_M"
#ifndef NULL 
#define NULL		((void *)0)
#endif


		/*	The *_syn modules are executed by install at compilation time.
			This execution is performed to determine if the associated
			element exists as a macro.   When the element exists as a
			macro, this macro when installed in the *_syn modules,
			returns MAC_ELEMENT_RET.

			When the element exists as a macro, install() will compile
			the remaining modules associated with the element twice.  Once
			with the fuction library and once with the macro library.

			This macro must be present in each *syn module to allow the
			module to exit when executed (interrogated) by install().
		*/
#define	IF_INSTALL_TEST_FOR_MACRO(arg) { \
	if(argc > 1) \
		if( ! (strcmp(argv[1], INSTALL_CALL)) ) \
			_exit(arg); \
}
