extern void same_lock(struct flock *, struct flock *);

#define	ZERO_OFFSET		((off_t)0)
#define	QUARTER_OFFSET	((off_t)Strlen/4)
#define	HALF_OFFSET		((off_t)Strlen/2)
#define	FILE_LENGTH		(Strlen)
#define	TOTAL_FILE		((off_t)0)
#define	TOTAL_FILE_LEN	((off_t)Strlen)
#define	HALF_FILE		((off_t)Strlen/2)
#define	QUARTER_FILE	((off_t) Strlen/4)

#define	CLOSE_LOCKED_FILE(fd)\
	cleanup("Close locked file.");\
	start\
		close(fd);\
	finis\

#define	DO_LOCK(funct,type)	\
	void funct(short locktype, int fd, short origin, off_t offset, off_t len, struct flock *flockptr) \
	{ \
		flockptr->l_type = locktype; \
		flockptr->l_whence = origin; \
		flockptr->l_start = offset; \
		flockptr->l_len = len; \
		flockptr->l_pid = (pid_t)0; \
		Zfcntl(fd, type, flockptr); \
	}

DO_LOCK(GET_LOCK, F_GETLK)
DO_LOCK(SET_LOCKW, F_SETLKW)
DO_LOCK(SET_LOCK, F_SETLK)

						/* Initialize a flock structure. */
#define	INIT_LOCK_STRUCT(locktype, origin, offset, len, flock) \
	{ \
		flock.l_type = locktype; \
		flock.l_whence = origin; \
		flock.l_start = offset; \
		flock.l_len = len; \
		flock.l_pid = (pid_t)0; \
	}
