/*
 	pcts_time.h - Specify relative relative speed of NIST-PCTS

   WAIT_FOR_TIME controls the delay when a test requires time for
   an event to occur.   This PCTS uses multiples of WAIT_FOR_TIME
   for all its delays.
   A WAIT_FOR_TIME of 1 is the minimum value.
   For systems which are slow, this value may be increased.
*/

#define	WAIT_FOR_TIME	1			/* Time to wait in seconds. */
