#include <unistd.h>
#include <chk_mcro.h>
extern	void sv_printf(char *, ...);
/* Macro for generating code to run the tests for each element. */
#define	NSUBTESTS	(sizeof(subs)/sizeof(pointer))
#define	RUN_TESTS(func) \
	int main(void) \
	{ \
		int i; \
		char	m_test[_POSIX_NAME_MAX +1]; \
		\
		setup(E_ ## func); \
		funct(E_ ## func); \
		for(i=0; i<NSUBTESTS; i++) \
			subtest(subs[i], E_ ## func); \
		\
					/* Run tests for macro if macro load modules exist. */ \
		sv_printf("\nMACRO Processing\n"); \
		for(i=1; i<NSUBTESTS; i++) { \
			strcpy(m_test, subs[i]); \
			strcat(m_test, MACRO_TEST_DESIGNATOR); \
			if(access(m_test, F_OK) != 0) \
				break; \
			subtest(m_test, E_ ## func);  \
		} \
		done(); \
	}
