struct cnfg {
	char	*name;
	char	*value;
	int		typ;
};

#ifndef SV_CONFIG
extern struct cnfg sv_params[];
#endif

#define	PCTS_PATH					((char *)(sv_params[0].value))
#define	ROOT_UID					*((uid_t *)(sv_params[1].value))
#define	ROOT_GID					*((gid_t *)(sv_params[2].value))
#define	BIN_UID						*((uid_t *)(sv_params[3].value))
#define	BIN_GID						*((gid_t *)(sv_params[4].value))
#define	UID							*((uid_t *)(sv_params[5].value))
#define	GID							*((gid_t *)(sv_params[6].value))
#define	ANOTHER_UID					*((uid_t *)(sv_params[7].value))
#define	LOGNAME						((char *)(sv_params[8].value))
#define	SUPPLEMENTARY_GROUPS		((char *)(sv_params[9].value))
#define	UNUSED_GID					*((gid_t *)(sv_params[10].value))
#define	UNUSED_GROUP_NAME			((char *)(sv_params[11].value))
#define	UNUSED_LOGNAME				((char *)(sv_params[12].value))
#define	UNUSED_UID					*((uid_t *)(sv_params[13].value))
#define	GDB_ENTRY					((char *)(sv_params[14].value))
#define	PDB_ENTRY					((char *)(sv_params[15].value))
#define	PCD_READ_ONLY_FILE_SYSTEM	*((int *)(sv_params[16].value))
#define	GROUP_ID_OF_PARENT_DIR		*((int *)(sv_params[17].value))
#define	UNAME_INFO					((char *)(sv_params[18].value))
#define	PCTS_FS						((char *)(sv_params[19].value))
#define	TIME_PCTS_FS_TESTING		*((int *)(sv_params[20].value))
#define	BLOCK_SPECIAL				*((int *)(sv_params[21].value))
#define	CHAR_SPECIAL				*((int *)(sv_params[22].value))
#define	PORT_TTY					((char *)(sv_params[23].value))
#define	PORT_LOOP					((char *)(sv_params[24].value))
#define	FILENAME_OF_TERMINAL_FILE	((char *)(sv_params[25].value))
#define	GTI_MODEM_CONTROL			*((int *)(sv_params[26].value))
#define	GTI_START_STOP				*((int *)(sv_params[27].value))
#define	GTI_BAUD_RATES				((char *)(sv_params[28].value))
#define	GTI_LOCKS					*((int *)(sv_params[29].value))
#define	GTI_LINE_CLOSE_DELAY		*((int *)(sv_params[30].value))
#define	PCTS_INVALID_SIGNAL			*((int *)(sv_params[31].value))
#define	PCTS_CHMOD_SET_IDS			*((int *)(sv_params[32].value))
#define	PCTS_ECHOE					((char *)(sv_params[33].value))
#define	PCTS_ECHOK					((char *)(sv_params[34].value))
#define	PCTS_GTI_BUFFERS_OUTPUT		*((int *)(sv_params[35].value))
#define	PCTS_INVALID_SIGNAL_NUMBER	*((int *)(sv_params[36].value))
#define	PCTS_INVALID_OWNER			*((int *)(sv_params[37].value))
#define	EINVAL_ACCESS				*((int *)(sv_params[38].value))
#define	EINVAL_SETPGID				*((pid_t *)(sv_params[39].value))
#define	EDEADLK_FCNTL				*((int *)(sv_params[40].value))
#define	EINVAL_SYSCONF				*((int *)(sv_params[41].value))
#define	EINVAL_WAITPID				*((int *)(sv_params[42].value))
#define	INVALID_UID_VALUE			*((uid_t *)(sv_params[43].value))
#define	INVALID_GID_VALUE			*((gid_t *)(sv_params[44].value))
#define	INVALID_PID_VALUE			*((pid_t *)(sv_params[45].value))
#define	EMFILE_OPENDIR				*((int *)(sv_params[46].value))
#define	EBADF_READDIR				*((int *)(sv_params[47].value))
#define	EBADF_CLOSEDIR				*((int *)(sv_params[48].value))
#define	APP_ACCESS					*((int *)(sv_params[49].value))
#define	APP_CHOWN					*((int *)(sv_params[50].value))
#define	APP_UTIME					*((int *)(sv_params[51].value))
#define	FILLER_1					*((int *)(sv_params[52].value))
#define	PCD_DIR_TYPE				*((int *)(sv_params[53].value))
#define	PCD_LINK_TO_DIRECTORY		*((int *)(sv_params[54].value))
#define	PCD_LINK_FILE_SYSTEM		*((int *)(sv_params[55].value))
#define	PCD_WRITE_PERM_TO_RENAME	*((int *)(sv_params[56].value))
#define	PCD_CREAT_LINK_COUNT		*((int *)(sv_params[57].value))
#define	PCD_NO_LOCK_FILE_TYPE		*((int *)(sv_params[58].value))
#define	PCD_UNLINK_DIRECTORY		*((int *)(sv_params[59].value))
#define	A_D_TO_P_WHEN_C_P_T			*((int *)(sv_params[60].value))
#define	ANOTHER_LOCALE				((char *)(sv_params[61].value))
#define	INVALID_PGRP_ID_VALUE		*((pid_t *)(sv_params[62].value))
#define	TIME_ACQUIRE_XMITTED_DATA	*((int *)(sv_params[63].value))
#define	CONFIGD						*((int *)(sv_params[64].value))

#ifdef SV_CONFIG
/* Data Types */

#define		UCHAR	1	/*Value points to a uchar */
#define		CHAR	2	/*Value points to a char */
#define		USHORT	3	/*Value points to a ushort */
#define		SHORT	4	/*Value points to a short */
#define		UINT	5	/*Value points to a uint */
#define		INT		6	/*Value points to a int */
#define		ULONG	7	/*Value points to a ulong */
#define		LONG	8	/*Value points to a long */
#define		STRING	9	/*Value points to a string */
#define		UID_T	10	/*Value points to a uid_t */
#define		GID_T	11	/*Value points to a gid_t */
#define		PID_T	12	/*Value points to a pid_t */

static  char		null_str[]="";
static	uid_t		ZROOT_UID=0;
static	gid_t		ZROOT_GID=0;
static	uid_t		ZBIN_UID=1000;
static	gid_t		ZBIN_GID=1001;
static	uid_t		ZUID=1002;
static	gid_t		ZGID=1003;
static	int			ZANOTHER_UID=1004;
static	gid_t		ZUNUSED_GID=2001;
static	uid_t		ZUNUSED_UID=2002;
static	int			ZPCD_READ_ONLY_FILE_SYSTEM=0;
static	int			ZGROUP_ID_OF_PARENT_DIR=0;
static	int			ZGTI_MODEM_CONTROL=1;
static	int			ZGTI_START_STOP=1;
static	int			ZFILLER_1=1;
static	int			ZEINVAL_ACCESS=0;
static	int			ZEINVAL_SYSCONF=-1;
static	uid_t		ZINVALID_UID_VALUE=7777;
static	gid_t		ZINVALID_GID_VALUE=7777;
static	int			ZPCTS_INVALID_SIGNAL=1;
static	pid_t		ZINVALID_PID_VALUE=(pid_t)7777;
static	int			ZGTI_LOCKS=0;
static	pid_t		ZEINVAL_SETPGID=(pid_t)0;
static	int			ZEDEADLK_FCNTL=1;
static	int			ZTIME_PCTS_FS_TESTING=10;
static	int			ZBLOCK_SPECIAL=0;
static	int			ZCHAR_SPECIAL=0;
static	int			ZEINVAL_WAITPID=7777;
static	int			ZGTI_LINE_CLOSE_DELAY=0;
static	int			ZEMFILE_OPENDIR=0;
static	int			ZEBADF_READDIR=0;
static	int			ZEBADF_CLOSEDIR=0;
static	int			ZAPP_ACCESS=0;
static	int			ZPCD_UNLINK_DIRECTORY=0;
static	int			ZPCTS_CHMOD_SET_IDS=0;
static	int			ZAPP_CHOWN=0;
static	int			ZAPP_UTIME=0;
static	int			ZPCD_DIR_TYPE=0;
static	int			ZPCD_LINK_TO_DIRECTORY=0;
static	int			ZPCD_LINK_FILE_SYSTEM=0;
static	int			ZPCD_WRITE_PERM_TO_RENAME=0;
static	int			ZPCD_CREAT_LINK_COUNT=0;
static	int			ZPCD_NO_LOCK_FILE_TYPE=0;
static	int			ZPCTS_GTI_BUFFERS_OUTPUT=1;
static	int			ZPCTS_INVALID_SIGNAL_NUMBER=0;
static	int			ZPCTS_INVALID_OWNER=0;
static	int			ZA_D_TO_P_WHEN_C_P_T=0;
static	pid_t		ZINVALID_PGRP_ID_VALUE=(pid_t)(-1);
static	int			ZTIME_ACQUIRE_XMITTED_DATA=0;
static	int			ZCONFIGD=0;	/*Config() status flag */

struct cnfg sv_params[] = {
	{"PCTS_PATH",null_str,STRING},
	{"ROOT_UID",(char *)&ZROOT_UID,UID_T},
	{"ROOT_GID",(char *)&ZROOT_GID,GID_T},
	{"BIN_UID",(char *)&ZBIN_UID,UID_T},
	{"BIN_GID",(char *)&ZBIN_GID,GID_T},
	{"UID",(char *)&ZUID,UID_T},
	{"GID",(char *)&ZGID,GID_T},
	{"ANOTHER_UID",(char *)&ZANOTHER_UID,UID_T},
	{"LOGNAME",null_str,STRING},
	{"SUPPLEMENTARY_GROUPS",null_str,STRING},
	{"UNUSED_GID",(char *)&ZUNUSED_GID,GID_T},
	{"UNUSED_GROUP_NAME",null_str,STRING},
	{"UNUSED_LOGNAME",null_str,STRING},
	{"UNUSED_UID",(char *)&ZUNUSED_UID,UID_T},
	{"GDB_ENTRY",null_str,STRING},
	{"PDB_ENTRY",null_str,STRING},
	{"PCD_READ_ONLY_FILE_SYSTEM",(char *)&ZPCD_READ_ONLY_FILE_SYSTEM,INT},
	{"GROUP_ID_OF_PARENT_DIR",(char *)&ZGROUP_ID_OF_PARENT_DIR,INT},
	{"UNAME_INFO",null_str,STRING},
	{"PCTS_FS",null_str,STRING},
	{"TIME_PCTS_FS_TESTING",(char *)&ZTIME_PCTS_FS_TESTING,INT},
	{"BLOCK_SPECIAL",(char *)&ZBLOCK_SPECIAL,INT},
	{"CHAR_SPECIAL",(char *)&ZCHAR_SPECIAL,INT},
	{"PORT_TTY",null_str,STRING},
	{"PORT_LOOP",null_str,STRING},
	{"FILENAME_OF_TERMINAL_FILE",null_str,STRING},
	{"GTI_MODEM_CONTROL",(char *)&ZGTI_MODEM_CONTROL,INT},
	{"GTI_START_STOP",(char *)&ZGTI_START_STOP,INT},
	{"GTI_BAUD_RATES",null_str,STRING},
	{"GTI_LOCKS",(char *)&ZGTI_LOCKS,INT},
	{"GTI_LINE_CLOSE_DELAY",(char *)&ZGTI_LINE_CLOSE_DELAY,INT},
	{"PCTS_INVALID_SIGNAL",(char *)&ZPCTS_INVALID_SIGNAL,INT},
	{"PCTS_CHMOD_SET_IDS",(char *)&ZPCTS_CHMOD_SET_IDS,INT},
	{"PCTS_ECHOE",null_str,STRING},
	{"PCTS_ECHOK",null_str,STRING},
	{"PCTS_GTI_BUFFERS_OUTPUT",(char *)&ZPCTS_GTI_BUFFERS_OUTPUT,INT},
	{"PCTS_INVALID_SIGNAL_NUMBER",(char *)&ZPCTS_INVALID_SIGNAL_NUMBER,INT},
	{"PCTS_INVALID_OWNER",(char *)&ZPCTS_INVALID_OWNER,INT},
	{"EINVAL_ACCESS",(char *)&ZEINVAL_ACCESS,INT},
	{"EINVAL_SETPGID",(char *)&ZEINVAL_SETPGID,PID_T},
	{"EDEADLK_FCNTL",(char *)&ZEDEADLK_FCNTL,INT},
	{"EINVAL_SYSCONF",(char *)&ZEINVAL_SYSCONF,INT},
	{"EINVAL_WAITPID",(char *)&ZEINVAL_WAITPID,INT},
	{"INVALID_UID_VALUE",(char *)&ZINVALID_UID_VALUE,UID_T},
	{"INVALID_GID_VALUE",(char *)&ZINVALID_GID_VALUE,GID_T},
	{"INVALID_PID_VALUE",(char *)&ZINVALID_PID_VALUE,PID_T},
	{"EMFILE_OPENDIR",(char *)&ZEMFILE_OPENDIR,INT},
	{"EBADF_READDIR",(char *)&ZEBADF_READDIR,INT},
	{"EBADF_CLOSEDIR",(char *)&ZEBADF_CLOSEDIR,INT},
	{"APP_ACCESS",(char *)&ZAPP_ACCESS,INT},
	{"APP_CHOWN",(char *)&ZAPP_CHOWN,INT},
	{"APP_UTIME",(char *)&ZAPP_UTIME,INT},
	{"FILLER_1",(char *)&ZFILLER_1,INT},
	{"PCD_DIR_TYPE",(char *)&ZPCD_DIR_TYPE,INT},
	{"PCD_LINK_TO_DIRECTORY",(char *)&ZPCD_LINK_TO_DIRECTORY,INT},
	{"PCD_LINK_FILE_SYSTEM",(char *)&ZPCD_LINK_FILE_SYSTEM,INT},
	{"PCD_WRITE_PERM_TO_RENAME",(char *)&ZPCD_WRITE_PERM_TO_RENAME,INT},
	{"PCD_CREAT_LINK_COUNT",(char *)&ZPCD_CREAT_LINK_COUNT,INT},
	{"PCD_NO_LOCK_FILE_TYPE",(char *)&ZPCD_NO_LOCK_FILE_TYPE,INT},
	{"PCD_UNLINK_DIRECTORY",(char *)&ZPCD_UNLINK_DIRECTORY,INT},
	{"A_D_TO_P_WHEN_C_P_T",(char *)&ZA_D_TO_P_WHEN_C_P_T,INT},
	{"ANOTHER_LOCALE",null_str,STRING},
	{"INVALID_PGRP_ID_VALUE",(char *)&ZINVALID_PGRP_ID_VALUE,PID_T},
	{"TIME_ACQUIRE_XMITTED_DATA",(char *)&ZTIME_ACQUIRE_XMITTED_DATA,INT},
	{"CONFIGD",(char *)&ZCONFIGD},
};

/*
** Do not include CONFIGD in the list of assignable named entries
*/
#define NPARMS	((sizeof(sv_params)/sizeof(struct cnfg))-1)

#endif

