#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include <errno.h>

/*
 * some magic so that errno values can used as arguments to expecting.
 * the evaluation function needs a flag to tell it that there is an
 * actual value set against which it must check, and whether the value
 * is an expected return value, or an expected errno.  Before the errno
 * values passed to the expecting() function, sv_expecting is set to
 * SV_ERRN, to indicate this is an expected errno.
 */

#ifdef	E2BIG
int	ZE2BIG(void)
{
	return(E2BIG);
}
#endif

#ifdef	EACCES	
int	ZEACCES(void)
{
	return(EACCES);
}
#endif

#ifdef	EAGAIN	
int	ZEAGAIN(void)
{
	return(EAGAIN);
}
#endif

#ifdef	EBADF	
int	ZEBADF(void)
{
	return(EBADF);
}
#endif

#ifdef	EBUSY	
int	ZEBUSY(void)
{
	return(EBUSY);
}
#endif

#ifdef	ECHILD	
int	ZECHILD(void)
{
	return(ECHILD);
}
#endif

#ifdef	EDEADLK	
int	ZEDEADLK(void)
{
	return(EDEADLK);
}
#endif

#ifdef	EDOM	
int	ZEDOM(void)
{
	return(EDOM);
}
#endif

#ifdef	EEXIST	
int	ZEEXIST(void)
{
	return(EEXIST);
}
#endif

#ifdef	EFAULT	
int	ZEFAULT(void)
{
	return(EFAULT);
}
#endif

#ifdef	EFBIG	
int	ZEFBIG(void)
{
	return(EFBIG);
}
#endif

#ifdef	EINTR	
int	ZEINTR(void)
{
	return(EINTR);
}
#endif

#ifdef	EINVAL	
int	ZEINVAL(void)
{
	return(EINVAL);
}
#endif

#ifdef	EIO	
int	ZEIO(void)
{
	return(EIO);
}
#endif

#ifdef	EISDIR	
int	ZEISDIR(void)
{
	return(EISDIR);
}
#endif

#ifdef	EMFILE	
int	ZEMFILE(void)
{
	return(EMFILE);
}
#endif

#ifdef	EMLINK	
int	ZEMLINK(void)
{
	return(EMLINK);
}
#endif

#ifdef	ENAMETOOLONG
int	ZENAMETOOLONG(void)
{
	return(ENAMETOOLONG);
}
#endif

#ifdef	ENFILE	
int	ZENFILE(void)
{
	return(ENFILE);
}
#endif

#ifdef	ENODEV	
int	ZENODEV(void)
{
	return(ENODEV);
}
#endif

#ifdef	ENOENT	
int	ZENOENT(void)
{
	return(ENOENT);
}
#endif

#ifdef	ENOEXEC	
int	ZENOEXEC(void)
{
	return(ENOEXEC);
}
#endif

#ifdef ENOLCK
int	ZENOLCK(void)
{
	return(ENOLCK);
}
#endif

#ifdef	ENOMEM	
int	ZENOMEM(void)
{
	return(ENOMEM);
}
#endif

#ifdef	ENOSPC	
int	ZENOSPC(void)
{
	return(ENOSPC);
}
#endif

#ifdef	ENOSYS
int	ZENOSYS(void)
{
	return(ENOSYS);
}
#endif

#ifdef	ENOTDIR	
int	ZENOTDIR(void)
{
	return(ENOTDIR);
}
#endif

#ifdef	ENOTEMPTY
int	ZENOTEMPTY(void)
{
	return(ENOTEMPTY);
}
#endif

#ifdef	ENOTTY	
int	ZENOTTY(void)
{
	return(ENOTTY);
}
#endif

#ifdef	ENXIO	
int	ZENXIO(void)
{
	return(ENXIO);
}
#endif

#ifdef	EPERM	
int	ZEPERM(void)
{
	return(EPERM);
}
#endif

#ifdef	EPIPE	
int	ZEPIPE(void)
{
	return(EPIPE);
}
#endif

#ifdef	ERANGE	
int	ZERANGE(void)
{
	return(ERANGE);
}
#endif

#ifdef	EROFS	
int	ZEROFS(void)
{
	return(EROFS);
}
#endif

#ifdef	ESPIPE	
int	ZESPIPE(void)
{
	return(ESPIPE);
}
#endif

#ifdef	ESRCH	
int	ZESRCH(void)
{
	return(ESRCH);
}
#endif

#ifdef	EXDEV	
int	ZEXDEV(void)
{
	return(EXDEV);
}
#endif
