/* z_atol.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef atol
#endif

static char *format(long *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", *val);
	return(buf);
}

static int compare(long *a, long *b)
{
	return(*a == *b);
}

extern	long *sv_getl(void);

static struct ftable Tatol = {
	"atol",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_getl,
	0,
};

long  Zatol(const char *str)
{
	long ret_val;

	errno = 0;
	ret_val = atol(str);
	evaluate(&Tatol, (pointer)&ret_val);
	return(ret_val);
}
