/* z_isatty.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef isatty
#endif

static int success(int *val)
{
	return((*val) == 1);
}

static int failure(int *val)
{
	return((*val)? 0 : 1);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%s", (*val)?"TRUE":"FALSE");
	return(buf);
}

static int compare(int *a, int *b)
{
	return(!*a == !*b);
}

extern	int *sv_geti(void);

static struct ftable Tisatty = {
	"isatty",
	"a return value of 1",
	"a return value of 0",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

int  Zisatty(int fildes)
{
	int ret_val;

	errno = 0;
	ret_val = isatty(fildes);
	evaluate(&Tisatty, (pointer)&ret_val);
	return(ret_val);
}
