/* z_isupper.c */

#include <z_pcts.h>
#include <ctype.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef isupper
#endif

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%s", (*val)?"TRUE":"FALSE");
	return(buf);
}

static int compare(int *a, int *b)
{
	return(!*a == !*b);
}

extern	int *sv_geti(void);

static struct ftable Tisupper = {
	"isupper",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Zisupper(int c)
{
	int ret_val;

	errno = 0;
	ret_val = isupper(c);
	evaluate(&Tisupper, (pointer)&ret_val);
	return(ret_val);
}
