/* z_perror.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef perror
#endif

static char *format(void)
{
	return("void/undefined");
}

static int compare(void)
{
	return( 0 );
}

static struct ftable Tperror = {
	"perror",
	"return from the function",
	"not defined",
	format,
	compare,
	RET,
	(ifunctptr)0,
	(pfunctptr)0,
	0,
};

void  Zperror(char *s)
{
	perror(s);
	evaluate( &Tperror, (pointer)0 );
	return;
}
