/* z_strcspn.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef strcspn
#endif

static int success(int *val)
{
	return((*val) >= 0);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tstrcspn = {
	"strcspn",
	"a return value of at least 0",
	"not defined",
	format,
	compare,
	success,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

size_t  Zstrcspn(const char *s1, const char *s2)
{
	int ret_val;

	errno = 0;
	ret_val = strcspn(s1, s2);
	evaluate(&Tstrcspn, (pointer)&ret_val);
	return(ret_val);
}
