#include	<pcts_ass.h>

#include	<termios.h>
#include	<sv_env.h>


int	main(void)
{
	struct termios termios;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	continue_on(ERROR);

	assertion(1, BASE);
	start
		testing("The struct termios is defined in header file <termios.h>.");
		testing("	Definition of struct termios is tested by the");
		testing("	compilation phase of this module.");
		start
		finis
	finis

	assertion(2, BASE);
	start
		TYP_CHK_UNSIGNED_INTEGRAL(tcflag_t);

		TYP_CHK_UNSIGNED_INTEGRAL(cc_t);
	finis

	assertion(3, BASE);
	start
		testing("Flags c_iflag, c_oflag, c_cflag, and c_lflag are defined");
		testing("as type tcflag_t in struct termios.");
		start
			termios.c_iflag = (tcflag_t)0;
			termios.c_oflag = (tcflag_t)0;
			termios.c_cflag = (tcflag_t)0;
			termios.c_lflag = (tcflag_t)0;

			TYP_CHK_ENTITY(termios.c_iflag, tcflag_t);
			TYP_CHK_ENTITY(termios.c_oflag, tcflag_t);
			TYP_CHK_ENTITY(termios.c_cflag, tcflag_t);
			TYP_CHK_ENTITY(termios.c_lflag, tcflag_t);
		finis
	finis

	assertion(4, BASE);
	start
		testing("NCCS is defined is the header <termios.h>.");
		start
			exit_on(ERROR);
#ifndef NCCS
			error("NCCS not defined in header <termios.h>.");
#endif
		finis

		testing("NCCS is an integral value.");
		start
			if(((int) NCCS) != NCCS)
				error("NCCS is not an integral value.");
		finis

		testing("NCCS is a positive value.");
		start
			if(NCCS < 0)
				error("NCCS is a negative value.");
		finis
	finis

	assertion(5, EXTENDED);

	assertion(6, BASE);
	start
		testing("\"c_cc\" defined as an array of size NCCS and");
		testing("type \"cc_t\" in the \"termios\" structure.");
		start
			TYP_CHK_ENTITY_ARRAY(termios.c_cc, cc_t, NCCS);
		finis
	finis

	done();
}
