#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.2b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcdrain
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcdrain. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCDRAIN);
	funct(E_TCDRAIN);

	assertion(2, BASE);
	start
#ifdef tcdrain
		int		fildes;
		TYP_CHK_FUNCT_INT(tcdrain(fildes), int);
#else
		not_implemented("tcdrain() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcdrain
		if(system((char *)0)) {
			chk_mcro(E_TCDRAIN, CLAUSE);
		} else {
			prep("Obtain macro tcdrain() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcdrain() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcdrain() as a macro");
#endif
	finis


#undef	tcdrain

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcdrain(int);
		finis
	finis

	done();
}
