#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.2d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcflush
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcflush. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCFLUSH);
	funct(E_TCFLUSH);

	assertion(2, BASE);
	start
#ifdef tcflush
		int	fildes, queue_sel;
		TYP_CHK_FUNCT_INT(tcflush(fildes, queue_sel), int);
#else
		not_implemented("tcflush() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcflush
		if(system((char *)0)) {
			chk_mcro(E_TCFLUSH, CLAUSE);
		} else {
			prep("Obtain macro tcflush() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcflush() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcflush() as a macro");
#endif
	finis


#undef	tcflush

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcflush(int, int);
		finis
	finis

	done();
}
