#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcsetattr
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcsetattr. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCSETATTR);
	funct(E_TCSETATTR);

	assertion(2, BASE);
	start
#ifdef tcsetattr
		int		fildes, opt_action;
		struct	termios	*termios_p;
		TYP_CHK_FUNCT_INT(tcsetattr(fildes, opt_action, termios_p), int);
#else
		not_implemented("tcsetattr() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcsetattr
		if(system((char *)0)) {
			chk_mcro(E_TCSETATTR, CLAUSE);
		} else {
			prep("Obtain macro tcsetattr() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcsetattr() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcsetattr() as a macro");
#endif
	finis


#undef	tcsetattr

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcsetattr(int, int, const struct termios *);
		finis
	finis

	done();
}
