#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<termios.h>

#include	<sv_env.h>

#define	CLAUSE		"7.2.4"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tcsetpgrp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tcsetpgrp. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TCSETPGRP);
	funct(E_TCSETPGRP);

	assertion(2, BASE);
	start
#ifdef tcsetpgrp
		int		fildes;
		pid_t	pgrp_id;
		TYP_CHK_FUNCT_INT(tcsetpgrp(fildes, pgrp_id), int);
#else
		not_implemented("tcsetpgrp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tcsetpgrp
		if(system((char *)0)) {
			chk_mcro(E_TCSETPGRP, CLAUSE);
		} else {
			prep("Obtain macro tcsetpgrp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tcsetpgrp() macro provided in",
					"<termios.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tcsetpgrp() as a macro");
#endif
	finis


#undef	tcsetpgrp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tcsetpgrp(int, pid_t);
		finis
	finis

	done();
}
