#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	struct	stat st_buf;

	setup(E_CHOWN);
	funct(E_CHOWN);

	assertion(19, BASE);
	start
		if(APP_CHOWN) {
			testing("Call to chown() returns value zero and sets the user");
			testing("and group ID to the values provided.");
			start
					/* Data file has user and group ID set to owner BIN. */
				Zstrcpy(path, data_path());
				Zstrcat(path, "t_chown_bin");
	
				expecting((int) 0);
				Zchown(path, UID, GID);
				Zstat(path, &st_buf);
				if(st_buf.st_gid != GID)
					error("%s\"%s\".\n%s%lu\n%s%lu",
							"Call to stat() reported unexpected group ID for ",
							path,
							"Expected:	",
							(unsigned long) GID,
							"Actual:	",
							(unsigned long) st_buf.st_gid);
				if(st_buf.st_uid != UID)
					error("%s\"%s\"\n%s%lu\n%s%lu",
							"Call to stat() reported unexpected user ID for ",
							path,
							"expected:	",
							(unsigned long) UID,
							"actual:	",
							(unsigned long) st_buf.st_uid);
			finis
		}
		else
			not_implemented("mechanism to create process to change owner of file");
	finis

	done();
}
