#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.2.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getcwd
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getcwd(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETCWD);
	funct(E_GETCWD);

	assertion(2, BASE);
	start
#ifdef getcwd
		char	*buf;
		TYP_CHK_FUNCT_PTR(getcwd(buf, 1), char);
#else
		not_implemented("getcwd() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getcwd
		if(system((char *)0)) {
			chk_mcro(E_GETCWD, CLAUSE);
		} else {
			prep("Obtain macro getcwd() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getcwd() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getcwd() as a macro");
#endif
	finis


#undef	getcwd

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *getcwd(char *, size_t);
		finis
	finis

	done();
}
