#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.3.4"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef link
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for link(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_LINK);
	funct(E_LINK);

	assertion(2, BASE);
	start
#ifdef link
		TYP_CHK_FUNCT_INT(link("ABC", "DEF"), int);
#else
		not_implemented("link() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	link
		if(system((char *)0)) {
			chk_mcro(E_LINK, CLAUSE);
		} else {
			prep("Obtain macro link() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that link() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("link() as a macro");
#endif
	finis


#undef	link

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int link(const char *, const char *);
		finis
	finis

	done();
}
