#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"5.5.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef rename
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for rename(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_RENAME);
	funct(E_RENAME);

	assertion(2, BASE);
	start
#ifdef rename
		TYP_CHK_FUNCT_INT(rename("ABC", "DEF"), int);
#else
		not_implemented("rename() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	rename
		if(system((char *)0)) {
			chk_mcro(E_RENAME, CLAUSE);
		} else {
			prep("Obtain macro rename() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that rename() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("rename() as a macro");
#endif
	finis


#undef	rename

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int rename(const char *, const char *);
		finis
	finis

	done();
}
