#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>

int	main(int argc, char **argv)
{
	setup(E_STAT_H);

	if(!(strcmp(*++argv, "S_ISUID"))) {
		ass_nu = atoi(*++argv);
		testing("S_ISUID mode set on file.");
		start
			if(geteuid() != BIN_UID)
				error("%s%d\n%s%d",
						"Expected: effective user ID is ",
						BIN_UID,
						"Actual: effective user ID is :	",
						geteuid());
		finis
	}
	else {
		ass_nu = atoi(*++argv);
		testing("S_ISGID mode set on file.");
		start
			if(getegid() != BIN_GID)
				error("%s%d\n%s%d",
						"Expected: effective group ID is ",
						BIN_GID,
						"Actual: effective group ID is ",
						getegid());
		finis
	}
		
	done();
}
