#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"5.5.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef unlink
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for unlink(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_UNLINK);
	funct(E_UNLINK);

	assertion(2, BASE);
	start
#ifdef unlink
		TYP_CHK_FUNCT_INT(unlink("ABC"), int);
#else
		not_implemented("unlink() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	unlink
		if(system((char *)0)) {
			chk_mcro(E_UNLINK, CLAUSE);
		} else {
			prep("Obtain macro unlink() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that unlink() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("unlink() as a macro");
#endif
	finis


#undef	unlink

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int unlink(const char *);
		finis
	finis

	done();
}
