#include	<pcts.h>

#include	<sv_env.h>
#include	"../ctime/c_locale.h"


int	main(void)
{
	time_t	timer;
	char	*loc_time;
	char	*utc_time;
	char	tz_env[100];				/* Contains TZ environment */
	int		hours;

	setup(E_ASCTIME);
	funct(E_ASCTIME);

	assertion(4, BASE);
	start
		for(hours=0; hours<24; hours += 11) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst-%2.2d", hours);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/

				timer = c_timer(1992,0,0,0,0);
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("Call to asctime(_timeptr_) converts the data from a");
			testing("structure pointed to by _timeptr_ to a specificly");
			testing("formatted 26 character string.");
			start
				exp_time(timer);
				utc_time = asctime(gmtime(&timer));
				if(strncmp(str_exp, utc_time, 24))
					error("%s\n%s%24.24s\n%s%24.24s",
					"Invalid string returned by call to asctime(gmtime()).",
					"Expected: ",
					str_exp,
					"Actual:   ",
					utc_time);
				if(*(utc_time +24) != '\n')
					error("%s\n%s\n%s%o (octal)",
						"Character 25 of string returned by asctime() wrong.",
						"Expected: \\n ",
						"Actual: ",
						*(utc_time +24));
				if(*(utc_time +25) != '\000')
					error("%s\n%s\n%s%o (octal)",
						"Character 26 of string returned by asctime() wrong.",
						"Expected: NULL ",
						"Actual: ",
						*(utc_time +25));
			finis
		}
	finis

	done();
}
