#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<time.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.55a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef asctime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for asctime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ASCTIME);
	funct(E_ASCTIME);

	assertion(2, BASE);
	start
#ifdef asctime
		struct	tm	*tm;
		TYP_CHK_ENTITY(asctime(tm), char *);
#else
		not_implemented("asctime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	asctime
		if(system((char *)0)) {
			chk_mcro(E_ASCTIME, CLAUSE);
		} else {
			prep("Obtain macro asctime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that asctime() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("asctime() as a macro");
#endif
	finis


#undef	asctime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *asctime(const struct tm *);
		finis
	finis

	done();
}
