#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef asin
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for asin(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ASIN);
	funct(E_ASIN);

	assertion(2, BASE);
	start
#ifdef asin
		double	value;
		TYP_CHK_ENTITY(asin(value),double);
#else
		not_implemented("asin() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	asin
		if(system((char *)0)) {
			chk_mcro(E_ASIN, CLAUSE);
		} else {
			prep("Obtain macro asin() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that asin() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("asin() as a macro");
#endif
	finis


#undef	asin

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double asin(double);
		finis
	finis

	done();
}
