#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.45c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef atol
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for atol(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ATOL);
	funct(E_ATOL);

	assertion(2, BASE);
	start
#ifdef atol
		char	str[] = "1";
		TYP_CHK_ENTITY(atol(str), long);
#else
		not_implemented("atol() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	atol
		if(system((char *)0)) {
			chk_mcro(E_ATOL, CLAUSE);
		} else {
			prep("Obtain macro atol() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that atol() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("atol() as a macro");
#endif
	finis


#undef	atol

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern long atol(const char *);
		finis
	finis

	done();
}
