#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.48a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef calloc
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for calloc(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_CALLOC);
	funct(E_CALLOC);

	assertion(2, BASE);
	start
#ifdef calloc
		TYP_CHK_PTR_VOID(calloc(1,1), void);
#else
		not_implemented("calloc() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	calloc
		if(system((char *)0)) {
			chk_mcro(E_CALLOC, CLAUSE);
		} else {
			prep("Obtain macro calloc() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that calloc() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("calloc() as a macro");
#endif
	finis


#undef	calloc

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void *calloc(size_t, size_t);
		finis
	finis

	done();
}
