#include	<pcts.h>

#include	<sv_env.h>

extern	char **environ;
extern	char *tzname[2];


int	main(void)
{
	time_t	timer = 1000;
	char	tz_env[100];				/* Contains TZ environment */

	setup(E_CTIME);
	funct(E_CTIME);


	assertion(15, BASE);
	start
		prep("Setup environment for testing and call ctime().");
		start
			sprintf(tz_env, "TZ=dst0std");
			environ[0] = (char *)0;
			put_env(tz_env);	/* Establish TZ environment.		*/
			(void) ctime(&timer);
		finis

		testing("TZ is of the form: TZ=%s", getenv("TZ"));
		testing("tzname[0] points to the standard timezone designation.");
		testing("tzname[1] points to the summer timezone designation.");
		start
			if(strncmp(tzname[0], getenv("TZ"), 3))
				error("tzname[0]: %s\nStandard designation: %3.3s",
												tzname[0], getenv("TZ"));
			if(strcmp(tzname[1], getenv("TZ") +4))
				error("tzname[1]: %s\nStandard designation: %3.3s",
												tzname[1], getenv("TZ") +4);
		finis


		prep("Setup environment for testing and call ctime().");
		start
			sprintf(tz_env, "TZ=ABC0DEF");
			environ[0] = (char *)0;
			put_env(tz_env);	/* Establish TZ environment.		*/
			(void) ctime(&timer);
		finis

		testing("TZ is of the form: TZ=%s", getenv("TZ"));
		testing("tzname[0] points to the standard timezone designation.");
		testing("tzname[1] points to the summer timezone designation.");
		start
			if(strncmp(tzname[0], getenv("TZ"), 3))
				error("tzname[0]: %s\nStandard designation: %3.3s",
												tzname[0], getenv("TZ"));
			if(strcmp(tzname[1], getenv("TZ") +4))
				error("tzname[1]: %s\nStandard designation: %3.3s",
												tzname[1], getenv("TZ") +4);
		finis
	finis

	assertion(16, BASE);
	start
		testing("Tested in assertions #9 - #14,");
		start
		finis
	finis

	done();
}
