#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.12"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fgetc
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fgetc(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FGETC);
	funct(E_FGETC);

	assertion(2, BASE);
	start
#ifdef fgetc
		TYP_CHK_FUNCT_INT(fgetc(stdin), int);
#else
		not_implemented("fgetc() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fgetc
		if(system((char *)0)) {
			chk_mcro(E_FGETC, CLAUSE);
		} else {
			prep("Obtain macro fgetc() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fgetc() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fgetc() as a macro");
#endif
	finis


#undef	fgetc

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fgetc(FILE *);
		finis
	finis

	done();
}
