#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.38"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fscanf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fscanf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FSCANF);
	funct(E_FSCANF);

	assertion(2, BASE);
	start
#ifdef fscanf
		char	c;
		char	msg[] = "%c";
		TYP_CHK_FUNCT_INT(fscanf(stdin, msg, &c), int);
#else
		not_implemented("fscanf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fscanf
		if(system((char *)0)) {
			chk_mcro(E_FSCANF, CLAUSE);
		} else {
			prep("Obtain macro fscanf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fscanf() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fscanf() as a macro");
#endif
	finis


#undef	fscanf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int fscanf(FILE *, const char *, ...);
		finis
	finis

	done();
}
