#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME "8.1.20_04"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	buffer[_POSIX_PIPE_BUF +1];
	FILE	*sfd;
	long	pos_beg, pos_end;

	setup(E_FTELL);
	funct(E_FTELL);

	assertion(4, BASE);
	start
		prep("Create test file with data.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			setvbuf(sfd, buffer, _IOFBF, _POSIX_PIPE_BUF);
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
		finis

		testing("The values returned from a call to ftell() before and after");
		testing("a call to fflush() are equal.");
		start
			pos_beg = Zftell(sfd);
			Zfflush(sfd);
			pos_end = Zftell(sfd);

			if(pos_beg != pos_end)
				error("%s\n%s%ld\n%s%ld\n",
					"Values from ftell() before and after fflush() vary.",
					"Expected: ",
					pos_beg,
					"Actual: ",
					pos_end);
		finis
	finis

	done();
}
