#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef iscntrl
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for iscntrl(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_ISCNTRL);
	funct(E_ISCNTRL);

	assertion(2, BASE);
	start
#ifdef iscntrl
		TYP_CHK_FUNCT_INT(iscntrl(1),int);
#else
		not_implemented("iscntrl() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	iscntrl
		if(system((char *)0)) {
			chk_mcro(E_ISCNTRL, CLAUSE);
		} else {
			prep("Obtain macro iscntrl() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that iscntrl() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("iscntrl() as a macro");
#endif
	finis


#undef	iscntrl

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int iscntrl(int);
		finis
	finis

	done();
}
