#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<math.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.4v"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef modf
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for modf(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_MODF);
	funct(E_MODF);

	assertion(2, BASE);
	start
#ifdef modf
		double	value, *value2;
		TYP_CHK_FUNCT(modf(value,value2),double);
#else
		not_implemented("modf() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	modf
		if(system((char *)0)) {
			chk_mcro(E_MODF, CLAUSE);
		} else {
			prep("Obtain macro modf() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that modf() macro provided in",
					"<math.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("modf() as a macro");
#endif
	finis


#undef	modf

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern double modf(double,double *);
		finis
	finis

	done();
}
