#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdlib.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.52b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef qsort
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for qsort(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_QSORT);
	funct(E_QSORT);

#ifdef qsort
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("qsort() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	qsort
		if(system((char *)0)) {
			chk_mcro(E_QSORT, CLAUSE);
		} else {
			prep("Obtain macro qsort() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that qsort() macro provided in",
					"<stdlib.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("qsort() as a macro");
#endif
	finis


#undef	qsort

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void qsort(void *, size_t, size_t,
							int (*)(const void *, const void *));
		finis
	finis

	done();
}
