#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define FILENAME "8.1.37_04"
char	String[] = "Hello, world!\n";
#define	Strlen	(sizeof(String) -1)


int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	inbuf[_POSIX_PIPE_BUF];
	int		fd;

	setup(E_SCANF);
	funct(E_SCANF);

	assertion(4, BASE);
	start
		time_t	s_time;

		prep("Establish stdin file with known data.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zopen(path, O_RDWR | O_CREAT, PROT_ALL);

			Zwrite(fd, String, Strlen);
			Zclose(fd);
			Zfreopen(path, "r", stdin);
		finis

		testing("A call to scanf() marks for update the st_atime field.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			Zscanf("%s", inbuf);
			trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
