#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<setjmp.h>
#include	<sv_env.h>

#define	CLAUSE		"8.3.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef siglongjmp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for siglongjmp(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGLONGJMP);
	funct(E_SIGLONGJMP);

#ifdef	siglongjmp
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("siglongjmp() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	siglongjmp
		if(system((char *)0)) {
			chk_mcro(E_SIGLONGJMP, CLAUSE);
		} else {
			prep("Obtain macro siglongjmp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that siglongjmp() macro provided in",
					"<setjmp.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("siglongjmp() as a macro");
#endif
	finis


#undef	siglongjmp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void siglongjmp(sigjmp_buf, int);
		finis
	finis

	done();
}
