#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53h"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strcspn
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strcspn(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRCSPN);
	funct(E_STRCSPN);

	assertion(2, BASE);
	start
#ifdef strcspn
		char	*s1, *s2;
		TYP_CHK_ENTITY(strcspn(s1, s2), size_t);
#else
		not_implemented("strcspn() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strcspn
		if(system((char *)0)) {
			chk_mcro(E_STRCSPN, CLAUSE);
		} else {
			prep("Obtain macro strcspn() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strcspn() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strcspn() as a macro");
#endif
	finis


#undef	strcspn

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern size_t strcspn(const char *, const char *);
		finis
	finis

	done();
}
