#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<time.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.59"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strftime
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strftime(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRFTIME);
	funct(E_STRFTIME);

	assertion(2, BASE);
	start
#ifdef strftime
		char	s[2];
		struct	tm	*tm;
		char	format[] = "%Z";
		TYP_CHK_FUNCT_INT(strftime(s, 2, format, tm), size_t);
#else
		not_implemented("strftime() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strftime
		if(system((char *)0)) {
			chk_mcro(E_STRFTIME, CLAUSE);
		} else {
			prep("Obtain macro strftime() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strftime() macro provided in",
					"<time.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strftime() as a macro");
#endif
	finis


#undef	strftime

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern size_t strftime(char *, size_t, const char *,
														const struct tm *);
		finis
	finis

	done();
}
