#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53d"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strncat
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strncat(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRNCAT);
	funct(E_STRNCAT);

	assertion(2, BASE);
	start
#ifdef strncat
		char	*s1, *s2;
		size_t	n;
		TYP_CHK_FUNCT_PTR(strncat(s1, s2, n), char);
#else
		not_implemented("strncat() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strncat
		if(system((char *)0)) {
			chk_mcro(E_STRNCAT, CLAUSE);
		} else {
			prep("Obtain macro strncat() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strncat() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strncat() as a macro");
#endif
	finis


#undef	strncat

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strncat(char *, const char *, size_t);
		finis
	finis

	done();
}
