#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<string.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.53j"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef strrchr
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for strrchr(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_STRRCHR);
	funct(E_STRRCHR);

	assertion(2, BASE);
	start
#ifdef strrchr
		char	*s1;
		TYP_CHK_FUNCT_PTR(strrchr(s1, 'C'), char);
#else
		not_implemented("strrchr() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	strrchr
		if(system((char *)0)) {
			chk_mcro(E_STRRCHR, CLAUSE);
		} else {
			prep("Obtain macro strrchr() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that strrchr() macro provided in",
					"<string.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("strrchr() as a macro");
#endif
	finis


#undef	strrchr

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *strrchr(const char *, int);
		finis
	finis

	done();
}
