#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<stdio.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.42"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tmpnam
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tmpnam(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TMPNAM);
	funct(E_TMPNAM);

	assertion(2, BASE);
	start
#ifdef tmpnam
		char *buf;
		TYP_CHK_FUNCT_PTR(tmpnam(buf), char);
#else
		not_implemented("tmpnam() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tmpnam
		if(system((char *)0)) {
			chk_mcro(E_TMPNAM, CLAUSE);
		} else {
			prep("Obtain macro tmpnam() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tmpnam() macro provided in",
					"<stdio.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tmpnam() as a macro");
#endif
	finis


#undef	tmpnam

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *tmpnam(char *);
		finis
	finis

	done();
}
