#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<ctype.h>
#include	<sv_env.h>

#define	CLAUSE		"8.1.2l"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef tolower
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for tolower(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TOLOWER);
	funct(E_TOLOWER);

	assertion(2, BASE);
	start
#ifdef tolower
		TYP_CHK_FUNCT_INT(tolower(1),int);
#else
		not_implemented("tolower() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	tolower
		if(system((char *)0)) {
			chk_mcro(E_TOLOWER, CLAUSE);
		} else {
			prep("Obtain macro tolower() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that tolower() macro provided in",
					"<ctype.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("tolower() as a macro");
#endif
	finis


#undef	tolower

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int tolower(int);
		finis
	finis

	done();
}
