#include	<pcts.h>

#include	<sv_env.h>

extern	char **environ;

#define	ENV_ARG1	"VAR1"
#define	ENV_ARG2	"VAR2"
#define	ENV1_DATA	"variable1"
#define	ENV2_DATA	"variable2"
#define	ENV1		"VAR1=variable1"
#define	ENV2		"VAR2=variable2"


int	main(void)
{
	char	*ret_val;

	setup(E_GETENV);
	funct(E_GETENV);

	assertion(4, BASE);
	start
		prep("Establish test environment");
		start
			environ[0] = (char *)0;
			put_env(ENV1);
			put_env(ENV2);
		finis
	
		testing("Call to getenv() returns proper environments.");
		start
			ret_val = Zgetenv(ENV_ARG1);
			if(strcmp(ret_val, ENV1_DATA))
				error("%s\n%s\"%s\".\n%s\"%s\".",
						"Incorrect environment data returned from getenv().",
						"Expected data: ",
						ENV1_DATA,
						"Actual data: ",
						ret_val);
		
			ret_val = Zgetenv(ENV_ARG2);
			if(strcmp(ret_val, ENV2_DATA))
				error("%s\n%s\"%s\".\n%s\"%s\".",
						"Incorrect environment data returned from getenv().",
						"Expected data: ",
						ENV2_DATA,
						"Actual data: ",
						ret_val);
		finis
	finis
	
	done();
}
