#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<stdlib.h>

#include	<sv_env.h>

#define	CLAUSE		"4.6.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getenv
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getenv. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETENV);
	funct(E_GETENV);

	assertion(2, BASE);
	start
#ifdef getenv
		char *str;
		TYP_CHK_FUNCT_PTR(getenv(str), char);
#else
		not_implemented("getenv() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getenv
		if(system((char *)0)) {
			chk_mcro(E_GETENV, CLAUSE);
		} else {
			prep("Obtain macro getenv() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getenv() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getenv() as a macro");
#endif
	finis


#undef	getenv

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern char *getenv(const char *);
		finis
	finis

	done();
}
