#include	<pcts.h>

#include	<Zunistd.h>
#include	<sv_env.h>

/*	This module has S_ISGID of BIN_GID.  */

int	main(void)
{
	setup(E_GETGID);
	funct(E_GETGID);

	assertion(4, BASE);
	start
		prep("Ensure effective group-ID is BIN.");
		start
			if(getegid() != BIN_GID)
				error("%s\n%s%d.\n%s%d.",
					"Incorrect effective group-ID for testing.",
					"Expected group-ID: ",
					BIN_GID,
					"Actual group-ID: ",
					geteuid());
		finis

		testing("Getgid() returns the real group ID of the calling process.");
		start
			uid_t	ret_val;

			ret_val = getgid();
	
			if (ret_val != GID)
				error("%s\n%s%d.\n%s%d.",
					"Incorrect return value from getgid().",
					"Expected group-ID: ",
					GID,
					"Actual group-ID: ",
					ret_val);
		finis
    finis

    done();
}
