#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.2.3"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getgroups
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getgroups. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETGROUPS);
	funct(E_GETGROUPS);

	assertion(2, BASE);
	start
#ifdef getgroups
		int		gidsetsize;
		gid_t	grouplist[10];
		TYP_CHK_FUNCT_INT(getgroups(gidsetsize, grouplist), int);
#else
		not_implemented("getgroups() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getgroups
		if(system((char *)0)) {
			chk_mcro(E_GETGROUPS, CLAUSE);
		} else {
			prep("Obtain macro getgroups() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getgroups() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getgroups() as a macro");
#endif
	finis


#undef	getgroups

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int getgroups(int,gid_t *);
		finis
	finis

	done();
}
