#include	<pcts.h>

#include	<Zunistd.h>
#include	<sv_env.h>


int	main(void)
{
	pid_t	pid;

	setup(E_GETPGRP);
	funct(E_GETPGRP);

	assertion(4, BASE);
	start
		exit_on( ERROR );

		FORK
			pid_t	c_pid, c_pgid;

			prep("Create a new process group.");
			start
				c_pid = Zgetpid();
				(void) Zsetsid();
			finis

			testing("A call to getpgrp() returns the process group ID");
			testing("of the calling process.");
			start
				c_pgid = Zgetpgrp();
				if(c_pgid != c_pid)
					error("%s%ld.\n%s%ld.",
						"Expected process group ID of ",
						(long) c_pid,
						"Actual process group returned from getpgrp() is ",
						(long) c_pgid);
			finis

			FORK
							/* Fork() does not change process group ID. */
				testing("A call to getpgrp() returns the process group ID");
				testing("of the calling process.");
				start
					c_pgid = Zgetpgrp();
					if(c_pgid != c_pid)
						error("%s%ld.\n%s%ld.",
							"Expected process group ID of ",
							(long) c_pid,
							"Actual process group returned from getpgrp() is ",
							(long) c_pgid);
				finis
			KROF
		KROF
	finis

	done();
}
