#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.3.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getpgrp
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getpgrp. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETPGRP);
	funct(E_GETPGRP);

	assertion(2, BASE);
	start
#ifdef getpgrp
		TYP_CHK_FUNCT_INT(getpgrp(), pid_t);
#else
		not_implemented("getpgrp() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getpgrp
		if(system((char *)0)) {
			chk_mcro(E_GETPGRP, CLAUSE);
		} else {
			prep("Obtain macro getpgrp() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getpgrp() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getpgrp() as a macro");
#endif
	finis


#undef	getpgrp

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern pid_t getpgrp(void);
		finis
	finis

	done();
}
