#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

#define	CLAUSE		"4.2.2a"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef setuid
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for setuid. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SETUID);
	funct(E_SETUID);

	assertion(2, BASE);
	start
#ifdef setuid
		uid_t	uid;
		TYP_CHK_FUNCT_INT(setuid(uid), int);
#else
		not_implemented("setuid() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	setuid
		if(system((char *)0)) {
			chk_mcro(E_SETUID, CLAUSE);
		} else {
			prep("Obtain macro setuid() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that setuid() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("setuid() as a macro");
#endif
	finis


#undef	setuid

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int setuid(uid_t);
		finis
	finis

	done();
}
