#include	<pcts_ass.h>

#include	<sys/types.h>
#include	<Zunistd.h>

#include	<sv_env.h>


int	main(void)
{
	setup(E_SYSCONF);
	funct(E_SYSCONF);

	assertion(12, BASE);
	start
		testing("sysconf(_SC_POSIX_JOB_CONTROL) returns value other than -1.");
		start
			if(Zsysconf(_SC_JOB_CONTROL) == (long)-1)
				error("Call to sysconf(_SC_JOB_CONTROL) returned -1.");
		finis
	finis

	assertion(13, BASE);
	start
		testing("sysconf(_SC_SAVED_IDS) returns value other than -1.");
		start
			if(Zsysconf(_SC_SAVED_IDS) == (long)-1)
				error("Call to sysconf(_SC_SAVED_IDS) returned -1.");
		finis
	finis

	assertion(14, BASE);
	start
		testing("sysconf(_SC_VERSION) returns a value = to {_POSIX_VERSION}.");
		start
			long	ret_val;

			ret_val = Zsysconf(_SC_VERSION);
			if(ret_val != _POSIX_VERSION)
				error("%s\n%s%lu.\n%s%ld.\n",
					"Incorrect return value from sysconf().",
					"Expected value ({_POSIX_VERSION}) of ",
					(unsigned long) _POSIX_VERSION,
					"Actual value was ",
					ret_val);
		finis
	finis

	done();
}
