#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<pcts_timer.h>


int	main(void)
{
	clock_t	ret_val1, ret_val2;
	struct	tms	tms_buf;
	clock_t	clk_tck;

	setup(E_TIMES);
	funct(E_TIMES);

			/*	Successful completion, the arbitrary point in the past
				does not change between invocations of times() within the
				same process.
			*/
	assertion(10, BASE);
	start
		prep("Get value for {CLK_TCK}.");
		start
			exit_on(ERROR);
			clk_tck = (clock_t) Zsysconf(_SC_CLK_TCK);
		finis

		testing("On a call to times(), the arbitrary point in the past");
		testing("is constant between invocations of times() with the same");
		testing("process.");
		start
			SET_ALARM(2)
				ret_val1 = Ztimes(&tms_buf);
				for(;;) {
					ret_val2 = Ztimes(&tms_buf);
					if(	((ret_val2 -ret_val1) > clk_tck) ||
						((ret_val2 -ret_val1) < 0) )
						error("%s\n%s%lu.\n%s%lu.",
				  			"Value returned not based on constant reference.",
							"On invocation times() returned value is ",
							(unsigned long) ret_val1,
							"On next invocation times() returned value is ",
							(unsigned long) ret_val2);
					ret_val1 = ret_val2;
				}
			EXPECT_ALARM
		finis
    finis

	assertion(11, EXTENDED);

	done();
}
