#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<sys/types.h>
#include	<sys/times.h>

#include	<sv_env.h>

#define	CLAUSE		"4.5.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef times
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for times. */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_TIMES);
	funct(E_TIMES);

	assertion(2, BASE);
	start
#ifdef times
		struct	tms	tms_buf; 
		TYP_CHK_FUNCT_INT(times(&tms_buf), clock_t);
#else
		not_implemented("times() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	times
		if(system((char *)0)) {
			chk_mcro(E_TIMES, CLAUSE);
		} else {
			prep("Obtain macro times() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that times() macro provided in",
					"<sys/times.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("times() as a macro");
#endif
	finis


#undef	times

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern clock_t times(struct tms *);
		finis
	finis

	done();
}
