#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.2.2"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef _exit
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for _exit(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E__EXIT);
	funct(E__EXIT);

#ifdef _exit
	assertion(2, EXTENDED);
#else
	assertion(2, EXTENDED_TESTED);
	start
		not_implemented("_exit() as a macro");
	finis
#endif

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	_exit
		if(system((char *)0)) {
			chk_mcro(E__EXIT, CLAUSE);
		} else {
			prep("Obtain macro _exit() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that _exit() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("_exit() as a macro");
#endif
	finis


#undef	_exit

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern void _exit(int);
		finis
	finis

	done();
}
