#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

#include	"../execl/3.1.2_16.h"

#define	ID_LENGTH	10
char	a_indx[ID_LENGTH];
static	int		e_indx;

#define	FILENAME	"./3.1.2_16y"
static	char	*args[] = 	{
							a_indx,
							(char *)0,
						};

int	main(int argc, char *argv[])
{
	pid_t	pid;
	char	*passed_env[10];

	e_indx = atoi(*++argv);
	strcpy(a_indx, *argv);
	setup(e_indx);
	funct(e_indx);

	assertion(16, BASE);
	start
		FORK
					/* "environ" was established via prior execle() call. */

			prep("Establish an environment for passing via exec functions.");
			start
				passed_env[0] = ENV_PORTABILITY_1;
				passed_env[1] = ENV_PORTABILITY_2;
				passed_env[2] = ENV_PORTABILITY_3;
				passed_env[3] = ENV_PORTABILITY_4;
				passed_env[4] = ENV_PORTABILITY_5;
				passed_env[5] = (char *)0;
			finis

			prep("Execute proper exec module to test assertions.");
			start
			  switch(e_indx) {
				case E_EXECL:
					Zexecl(FILENAME, a_indx, (char *)0);
					break;
				case E_EXECLE:
					Zexecle(FILENAME, a_indx, (char *)0, passed_env);
					break;
				case E_EXECV:
		    		Zexecv(FILENAME, args);
					break;
				case E_EXECVE:
		    		Zexecve(FILENAME, args, passed_env);
					break;
				case E_EXECLP:
		    		Zexeclp(FILENAME, a_indx, (char *) 0);
					break;
				case E_EXECVP:
		    		Zexecvp(FILENAME, args);
					break;
				default:
					error("Bad indx \"%d\" passed.", e_indx);
			  }
			finis
		KROF
	finis

	done();
}
