#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

extern	char	**environ;


int main(int argc, char *argv[])
{
	int	e_index;
	char	*p_arg, *ptr;
	long	arg_max;
	long	byte_cnt;

	e_index = atoi(*argv);
	setup(e_index);
	funct(e_index);

  		/*
			When the number of bytes in the argument and environment list
			are less than or equal to {ARG_MAX} the arguments are
			available in the corresponding main() arguments and the
			environment is available from the external variable environ.
  		*/
	ass_nu = 19;
	prep("Determine {ARG_MAX}.");
	start
		arg_max = Zsysconf(_SC_ARG_MAX);
	finis

	testing("%s (%lu) bytes including arguments and",
					((arg_max > PCTS_ARG_MAX) || (arg_max == (long)-1)) ?
								"PCTS_ARG_MAX" : "{ARG_MAX}",
					((arg_max > PCTS_ARG_MAX) || (arg_max == (long)-1)) ?
								(unsigned long) PCTS_ARG_MAX :
								(unsigned long) arg_max);
	testing("environment were passed to the new process image.");
	start
		int	err_cnt;
				/* Add up environment and argument bytes passed. */
		if(environ == NULL)
			error("%s\n%s\n",
				"Expected environ to be non-NULL.",
				"Actually environ was NULL.");
		else if(*environ != NULL)
			error("%s\n%s\n",
				"Expected *environ to be NULL.",
				"Actually *environ was non-NULL.");
		else if(argv[1] == NULL)
			error("%s\n%s\n",
				"Expected second argument to be non-NULL.",
				"Actually second argument was NULL.");
		else if(argv[2] != NULL)
			error("%s\n%s\"%10.10s\".\n",
				"Expected third argument to be NULL.",
				"Actually third argument was: ",
				argv[2]);
		else {
				/*
				   Total exec data, in bytes, passed:
						Argument zero:
							Pointer to arg[0]	sizeof(char *),
							Data				strlen(a_indx),
							Null character      sizeof(char),
						Argument one:
							Pointer to arg[1]	sizeof(char *),
							Filler bytes		X,
							Null character      sizeof(char),
						Argument two:
							NULL pointer		sizeof(NULL),
						Environment:
							NULL pointer		sizeof(NULL),
				*/
														/* Environment		*/
			byte_cnt = sizeof(NULL);
														/* First argument	*/
			byte_cnt += sizeof(char *) +strlen(*argv) +sizeof(char);
			p_arg = *++argv;
														/* Second argument	*/
			byte_cnt += sizeof(char *) +strlen(*argv) +sizeof(char);
														/* Third argument	*/
			byte_cnt += sizeof(NULL);
			if(byte_cnt != ( ((arg_max>PCTS_ARG_MAX) || (arg_max==(long)-1)) ?
								(unsigned long) PCTS_ARG_MAX : arg_max) )
				error("%s\n%s%lu\n%s%lu\n",
					"Count of environment and argument bytes passed incorrect.",
					"Expected: ",
					((arg_max > PCTS_ARG_MAX) || (arg_max == (long)-1)) ?
												(unsigned long) PCTS_ARG_MAX :
												(unsigned long) arg_max,
					"Actual: ",
					(unsigned long) byte_cnt);
			for(err_cnt=0, ptr = p_arg; *ptr; ptr++)
				if(*ptr != 'z') {
					if(err_cnt++ > 10)
						break;
					error("%s%d%s\n%s%o\n",
						"Expected p_arg[",
						ptr -p_arg,
						"] to be character \"z\".",
						"Actually character was (in octal) ",
						*ptr);
				}
		}
	finis

	done();
}
