#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>

#define	FILENAME	"./3.1.2_45x"
										/* a_param1 is real group ID */
#define	PARAMETERS	a_indx, a_param1
#include	"exec.h"

#define	S_ISGID_SUPPORTED	8


int	main(int argc, char *argv[])
{
	SETUP_FOR_EXEC

	if(PCTS_CHMOD_SET_IDS != 0) {
		assertion(45, BASE);
		start
			FORK
				prep("Obtain supplementary group IDs and write to temp file."); 
				start
					int		fd;
					gid_t	*g_beg;
					int		n_grps;
					char	path[_POSIX_PATH_MAX +1];

					n_grps = Zgetgroups(0, (gid_t *)0);	/* Get number groups */
					g_beg =(gid_t *)Zmalloc((unsigned int)(sizeof(gid_t) *
																n_grps));
					(void) Zgetgroups(n_grps, g_beg);

					Zstrcpy(path, temp_path());
					Zstrcat(path, "sup_grps");
					fd = Zcreat(path, PROT_ALL);
					expecting(sizeof(gid_t) * n_grps);
					write(fd, (char *)g_beg, sizeof(gid_t) * n_grps);
					expecting(SUCCESS);
					Zclose(fd);
				finis
	
				prep("Pass as parameter real group ID of the calling process.");
				start
					environ[0] = (char *)0;			/* Reset "environ". */

		  			sprintf(a_param1, "%ld", (long) getgid());
				finis

				EXEC_MODULE(FILENAME)
			KROF
		finis
	}
	else
		assertion(45, NOT_TESTABLE);

	done();
}
