#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

/*	This module has:
						S_ISUID mode set to BIN_UID and
						S_ISGID mode set to BIN_GID.
*/

int main(int argc, char *argv[])
{
	setup(atoi(*argv));
	ass_nu = 46;

	prep("Check that IDs are correct on entering exec-ed module.");
	start
		exit_on(ERROR);
		expecting(UID);
		Zgetuid();
		expecting(GID);
		Zgetgid();
		expecting(BIN_UID);
		Zgeteuid();
		expecting(BIN_GID);
		Zgetegid();
	finis

	prep("Set effective user and group IDs to UID and GID respectively.");
	start
		Zsetuid(UID);
		Zsetgid(GID);
	finis

	testing("Effective user ID was saved.");
	start
		expecting(SUCCESS);
		Zsetuid(BIN_UID);
		expecting(BIN_UID);
		Zgeteuid();
	finis

	testing("Effective group ID was saved.");
	start
		expecting(SUCCESS);
		Zsetgid(BIN_GID);
		expecting(BIN_GID);
		Zgetegid();
	finis

	done();
}
