#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.2b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef execle
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for execle(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXECLE);
	funct(E_EXECLE);

	assertion(2, BASE);
	start
#ifdef execle
		TYP_CHK_FUNCT_INT(execle("ABC", "ABCD", (char *)0), int);
#else
		not_implemented("execle() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	execle
		if(system((char *)0)) {
			chk_mcro(E_EXECLE, CLAUSE);
		} else {
			prep("Obtain macro execle() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that execle() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("execle() as a macro");
#endif
	finis


#undef	execle

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int execle(const char *, const char *, ...);
		finis
	finis

	done();
}
