#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.2c"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef execv
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for execv(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_EXECV);
	funct(E_EXECV);

	assertion(2, BASE);
	start
#ifdef execv
		char **args;
		TYP_CHK_FUNCT_INT(execv("ABC", args), int);
#else
		not_implemented("execv() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	execv
		if(system((char *)0)) {
			chk_mcro(E_EXECV, CLAUSE);
		} else {
			prep("Obtain macro execv() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that execv() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("execv() as a macro");
#endif
	finis


#undef	execv

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int execv(const char *, char *const []);
		finis
	finis

	done();
}
