#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<unistd.h>
#include	<sv_env.h>

#define	CLAUSE		"3.1.1"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef fork
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for fork(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_FORK);
	funct(E_FORK);

	assertion(2, BASE);
	start
#ifdef fork
		TYP_CHK_FUNCT_INT(fork(), pid_t);
#else
		not_implemented("fork() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	fork
		if(system((char *)0)) {
			chk_mcro(E_FORK, CLAUSE);
		} else {
			prep("Obtain macro fork() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that fork() macro provided in",
					"<unistd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("fork() as a macro");
#endif
	finis


#undef	fork

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern pid_t fork(void);
		finis
	finis

	done();
}
