#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.4"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigaction
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigaction(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGACTION);
	funct(E_SIGACTION);

	assertion(2, BASE);
	start
#ifdef sigaction
		TYP_CHK_FUNCT_INT(sigaction(SIG_IGN, (char *)0, (char *)0), int);
#else
		not_implemented("sigaction() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigaction
		if(system((char *)0)) {
			chk_mcro(E_SIGACTION, CLAUSE);
		} else {
			prep("Obtain macro sigaction() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigaction() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigaction() as a macro");
#endif
	finis


#undef	sigaction

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigaction(int, const struct sigaction *, struct sigaction *);
		finis
	finis

	done();
}
