#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<signal.h>
#include	<sv_env.h>

#define	CLAUSE		"3.3.6"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef sigpending
		exit_val = MAC_ELEMENT_RET;		/* Macro exists for sigpending(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_SIGPENDING);
	funct(E_SIGPENDING);

	assertion(2, BASE);
	start
#ifdef sigpending
		sigset_t	set;
		TYP_CHK_FUNCT_INT(sigpending(&set), int);
#else
		not_implemented("sigpending() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	sigpending
		if(system((char *)0)) {
			chk_mcro(E_SIGPENDING, CLAUSE);
		} else {
			prep("Obtain macro sigpending() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that sigpending() macro provided in",
					"<signal.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("sigpending() as a macro");
#endif
	finis


#undef	sigpending

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern int sigpending(sigset_t *);
		finis
	finis

	done();
}
