#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<grp.h>
#include	<sv_env.h>

#define	CLAUSE		"9.2.1b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getgrnam
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getgrnam(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETGRNAM);
	funct(E_GETGRNAM);

	assertion(2, BASE);
	start
#ifdef getgrnam
		TYP_CHK_FUNCT_PTR(getgrnam("Name"), struct group);
#else
		not_implemented("getgrnam() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getgrnam
		if(system((char *)0)) {
			chk_mcro(E_GETGRNAM, CLAUSE);
		} else {
			prep("Obtain macro getgrnam() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getgrnam() macro provided in",
					"<grp.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getgrnam() as a macro");
#endif
	finis


#undef	getgrnam

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern struct group *getgrnam(const char *);
		finis
	finis

	done();
}
