#include	<pcts_ass.h>
#include	<chk_mcro.h>

#include	<pwd.h>
#include	<sv_env.h>

#define	CLAUSE		"9.2.2b"


int main(int argc, char *argv[])
{
	int	exit_val = 0;

#ifdef getpwnam
		exit_val = MAC_ELEMENT_RET;			/* Macro exists for getpwnam(). */
#endif
	IF_INSTALL_TEST_FOR_MACRO(exit_val)

	setup(E_GETPWNAM);
	funct(E_GETPWNAM);

	assertion(2, BASE);
	start
#ifdef getpwnam
		TYP_CHK_FUNCT_PTR(getpwnam("Name"), struct passwd);
#else
		not_implemented("getpwnam() as a macro");
#endif
	finis

	assertion(3, BASE);
	start
		break_on(ERROR);
#ifdef	getpwnam
		if(system((char *)0)) {
			chk_mcro(E_GETPWNAM, CLAUSE);
		} else {
			prep("Obtain macro getpwnam() from  proper header.");
			start
				error("%s\n%s\n%s\n%s\n",
					"ANSI C \"system()\" call not supported on this",
					"implementation and required for test of this assertion.",
					"APTL must verify that getpwnam() macro provided in",
					"<pwd.h> satisfies requirements of this assertion.");
			finis
		}
#else
	not_implemented("getpwnam() as a macro");
#endif
	finis


#undef	getpwnam

	assertion(1, BASE);
	start
		testing("Function prototype correct.");
		start
			extern struct passwd *getpwnam(const char *);
		finis
	finis

	done();
}
