/* z_free.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef free
#endif

static char *format(void)
{
	return("void/undefined");
}

static int compare(void)
{
	return(0);
}


static struct ftable Tfree = {
	"free",
	"return from the function",
	"not defined",
	format,
	compare,
	RET,
	(ifunctptr)0,
	(pfunctptr)0,
	0,
};

void  Zfree(void *ptr)
{
	errno = 0;
	free(ptr);
	evaluate(&Tfree, (pointer)0);
	return;
}
