/* z_strcmp.c */

#include <z_pcts.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef strcmp
#endif

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%s", (*val)?"TRUE":"FALSE");
	return(buf);
}

static int compare(int *a, int *b)
{
	return(!*a == !*b);
}

extern	int *sv_geti(void);

static struct ftable Tstrcmp = {
	"strcmp",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Zstrcmp(const char *s1, const char *s2)
{
	int ret_val;

	errno = 0;
	ret_val = strcmp(s1, s2);
	evaluate(&Tstrcmp, (pointer)&ret_val);
	return(ret_val);
}
